/*
 *    Copyright (c) 2003 by Quadrics Ltd.
 * 
 *    For licensing information please see the supplied COPYING file
 *
 */

#ident "@(#)$Id: devinfo.c,v 1.6 2005/04/13 09:31:47 addy Exp $"
/*      $Source: /cvs/master/quadrics/elanmod/modsrc/devinfo.c,v $*/

#include <qsnet/kernel.h>
#include <elan/elanmod.h>

int 
elan_get_devinfo(ELAN_DEV_IDX devidx, ELAN_DEVINFO *devinfo)
{
	ELAN_DEV_STRUCT *target;
	int                 res;

	ELANMOD_RWLOCK_READ(&elan_rwlock);

	target = elan_dev_find (devidx);

	if (IS_ERR (target))
		res = PTR_ERR(target);
	else
	{
		copyout(target->devinfo, devinfo, sizeof(ELAN_DEVINFO));
		res = ESUCCESS;
	}
	
	ELANMOD_RWLOCK_READ_UNLOCK(&elan_rwlock);
	return res;
}

int 
elan_get_position(ELAN_DEV_IDX devidx, ELAN_POSITION *position)
{
	ELAN_DEV_STRUCT *target;
	int                 res;

	ELANMOD_RWLOCK_READ(&elan_rwlock);

	target = elan_dev_find(devidx);

	if (IS_ERR (target))
		res = PTR_ERR(target);
	else
		res = target->ops->get_position(target->user_data, position);
	
	ELANMOD_RWLOCK_READ_UNLOCK(&elan_rwlock);
	return res;
}

int 
elan_set_position(ELAN_DEV_IDX devidx, unsigned short nodeId, unsigned short numNodes)
{
	ELAN_DEV_STRUCT *target;
	int                 res;

	ELANMOD_RWLOCK_WRITE(&elan_rwlock);

	target = elan_dev_find(devidx);

	if (IS_ERR (target))
		res = PTR_ERR (target);
	else
		res = target->ops->set_position(target->user_data, nodeId, numNodes);
	
	ELANMOD_RWLOCK_WRITE_UNLOCK(&elan_rwlock);
	return res;
}

/*
 * Local variables:
 * c-file-style: "linux"
 * End:
 */
