/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *    Copyright (c) 2002-2003 by Quadrics Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ifndef _ELAN3_EPDEBUG_H
#define _ELAN3_EPDEBUG_H

#ident "$Id: debug.h,v 1.21 2005/04/05 16:36:28 mike Exp $"
/*      $Source: /cvs/master/quadrics/epmod/debug.h,v $ */

extern unsigned int epdebug;
extern unsigned int epdebug_console;
extern unsigned int epdebug_cmlevel;
#if ! defined(CONFIG_EP_NO_CHECK_SUM)
extern unsigned int epdebug_check_sum;
#endif
#define DBG_CONFIG		0x00000001			/* Module configuration */
#define DBG_PROBE		0x00000002
#define DBG_ROUTETABLE		0x00000004
#define DBG_STATEMAP		0x00000008

#define DBG_CM			0x00000020
#define DBG_XMTR		0x00000040
#define DBG_RCVR		0x00000080
#define DBG_FORWARD		0x00000100
#define DBG_DISCON		0x00000200
#define DBG_EPTRAP		0x00000400
#define DBG_COMMAND		0x00000800
#define DBG_RETRY		0x00001000
#define DBG_DEBUG		0x00002000
#define DBG_NETWORK_ERROR	0x00004000
#define DBG_MSGSYS		0x00008000
#define DBG_MANAGER		0x00010000
#define DBG_KMAP		0x00020000
#define DBG_FAILOVER		0x00040000
#define DBG_MAPNMD		0x00080000
#define DBG_KMSG		0x00100000
#define DBG_SVC                 0x00200000
#define DBG_STABILISE		0x00400000

#if defined(DEBUG_PRINTF)

#  define EPRINTF0(m,fmt)	 		((epdebug&(m)) ? ep_debugf(m,fmt)                     : (void)0)
#  define EPRINTF1(m,fmt,a)			((epdebug&(m)) ? ep_debugf(m,fmt,a)                   : (void)0)
#  define EPRINTF2(m,fmt,a,b)			((epdebug&(m)) ? ep_debugf(m,fmt,a,b)                 : (void)0)
#  define EPRINTF3(m,fmt,a,b,c)			((epdebug&(m)) ? ep_debugf(m,fmt,a,b,c)               : (void)0)
#  define EPRINTF4(m,fmt,a,b,c,d)		((epdebug&(m)) ? ep_debugf(m,fmt,a,b,c,d)             : (void)0)
#  define EPRINTF5(m,fmt,a,b,c,d,e)		((epdebug&(m)) ? ep_debugf(m,fmt,a,b,c,d,e)           : (void)0)
#  define EPRINTF6(m,fmt,a,b,c,d,e,f)		((epdebug&(m)) ? ep_debugf(m,fmt,a,b,c,d,e,f)         : (void)0)
#  define EPRINTF7(m,fmt,a,b,c,d,e,f,g)		((epdebug&(m)) ? ep_debugf(m,fmt,a,b,c,d,e,f,g)       : (void)0)
#  define EPRINTF8(m,fmt,a,b,c,d,e,f,g,h)	((epdebug&(m)) ? ep_debugf(m,fmt,a,b,c,d,e,f,g,h)     : (void)0)
#  define EPRINTF9(m,fmt,a,b,c,d,e,f,g,h,i)	((epdebug&(m)) ? ep_debugf(m,fmt,a,b,c,d,e,f,g,h,i)   : (void)0)
#  define EPRINTF10(m,fmt,a,b,c,d,e,f,g,h,i,j)	((epdebug&(m)) ? ep_debugf(m,fmt,a,b,c,d,e,f,g,h,i,j) : (void)0)

#  define CPRINTF0(lvl,fmt)			(((lvl) <= epdebug_cmlevel) ? EPRINTF0(DBG_CM,fmt)                   : (void)0)
#  define CPRINTF1(lvl,fmt,a)			(((lvl) <= epdebug_cmlevel) ? EPRINTF1(DBG_CM,fmt,a)                 : (void)0)
#  define CPRINTF2(lvl,fmt,a,b)			(((lvl) <= epdebug_cmlevel) ? EPRINTF2(DBG_CM,fmt,a,b)               : (void)0)
#  define CPRINTF3(lvl,fmt,a,b,c)		(((lvl) <= epdebug_cmlevel) ? EPRINTF3(DBG_CM,fmt,a,b,c)             : (void)0)
#  define CPRINTF4(lvl,fmt,a,b,c,d)		(((lvl) <= epdebug_cmlevel) ? EPRINTF4(DBG_CM,fmt,a,b,c,d)           : (void)0)
#  define CPRINTF5(lvl,fmt,a,b,c,d,e)		(((lvl) <= epdebug_cmlevel) ? EPRINTF5(DBG_CM,fmt,a,b,c,d,e)         : (void)0)
#  define CPRINTF6(lvl,fmt,a,b,c,d,e,f)		(((lvl) <= epdebug_cmlevel) ? EPRINTF6(DBG_CM,fmt,a,b,c,d,e,f)       : (void)0)
#  define CPRINTF7(lvl,fmt,a,b,c,d,e,f,g)	(((lvl) <= epdebug_cmlevel) ? EPRINTF7(DBG_CM,fmt,a,b,c,d,e,f,g)     : (void)0)
#  define CPRINTF8(lvl,fmt,a,b,c,d,e,f,g,h)	(((lvl) <= epdebug_cmlevel) ? EPRINTF8(DBG_CM,fmt,a,b,c,d,e,f,g,h)   : (void)0)
#  define CPRINTF9(lvl,fmt,a,b,c,d,e,f,g,h,i)	(((lvl) <= epdebug_cmlevel) ? EPRINTF9(DBG_CM,fmt,a,b,c,d,e,f,g,h,i) : (void)0)

#if defined __GNUC__
extern void ep_debugf (long mode, char *fmt, ...) __attribute__ ((format (printf,2,3)));
#else
extern void ep_debugf (long mode, char *fmt, ...);
#endif

#else

#  define EPRINTF0(m,fmt)			(0)
#  define EPRINTF1(m,fmt,a)			(0)
#  define EPRINTF2(m,fmt,a,b)			(0)
#  define EPRINTF3(m,fmt,a,b,c)			(0)
#  define EPRINTF4(m,fmt,a,b,c,d)		(0)
#  define EPRINTF5(m,fmt,a,b,c,d,e)		(0)
#  define EPRINTF6(m,fmt,a,b,c,d,e,f)		(0)
#  define EPRINTF7(m,fmt,a,b,c,d,e,f,g)		(0)
#  define EPRINTF8(m,fmt,a,b,c,d,e,f,g,h)	(0)
#  define EPRINTF9(m,fmt,a,b,c,d,e,f,g,h,i)	(0)
#  define EPRINTF9(m,fmt,a,b,c,d,e,f,g,h,i,j)	(0)

#  define CPRINTF0(lvl,fmt)			(0)
#  define CPRINTF1(lvl,fmt,a)			(0)
#  define CPRINTF2(lvl,fmt,a,b)			(0)
#  define CPRINTF3(lvl,fmt,a,b,c)		(0)
#  define CPRINTF4(lvl,fmt,a,b,c,d)		(0)
#  define CPRINTF5(lvl,fmt,a,b,c,d,e)		(0)
#  define CPRINTF6(lvl,fmt,a,b,c,d,e,f)		(0)
#  define CPRINTF7(lvl,fmt,a,b,c,d,e,f,g)	(0)
#  define CPRINTF8(lvl,fmt,a,b,c,d,e,f,g,h)	(0)
#  define CPRINTF9(lvl,fmt,a,b,c,d,e,f,g,h,i)	(0)

#endif /* DEBUG */

extern DisplayInfo di_ep_debug;

/*
 * Local variables:
 * c-file-style: "stroustrup"
 * End:
 */
#endif /* _ELAN3_EPDEBUG_H */

