/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *    Copyright (c) 2002-2003 by Quadrics Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ident "@(#)$Id: debug_elan4.c,v 1.1 2004/05/19 10:21:04 david Exp $ $Name: QSNETMODULES-5-11-3_20050907 $"
/*      $Source: /cvs/master/quadrics/epmod/debug_elan4.c,v $*/

#include <qsnet/kernel.h>

#include <elan/kcomm.h>

#include "kcomm_vp.h"
#include "kcomm_elan4.h"
#include "conf_linux.h"
#include "debug.h"

static void
ep4_display_ecqs (EP4_RAIL *rail)
{
    struct list_head *el;
    unsigned long flags;
    int i;

    spin_lock_irqsave (&rail->r_ecq_lock, flags);
    for (i = 0; i <EP4_NUM_ECQ; i++)
    {
	list_for_each (el, &rail->r_ecq_list[i]) {
	    EP4_ECQ *ecq = list_entry (el, EP4_ECQ, ecq_link);

	    ep_debugf (DBG_DEBUG, "ECQ: type %d: avail %d cqnum %d\n", i, ecq->ecq_avail, elan4_cq2num (ecq->ecq_cq));
	}
    }
    spin_unlock_irqrestore (&rail->r_ecq_lock, flags);
}

void
ep4_debug_rail (EP_RAIL *r)
{
    EP4_RAIL *rail = (EP4_RAIL *) r;
    EP_SYS   *sys  = rail->r_generic.System;

    ep_debugf (DBG_DEBUG, "ep%d: is elan4 %d rev %c\n", rail->r_generic.Number,
	       rail->r_generic.Devinfo.dev_instance, 'a' + rail->r_generic.Devinfo.dev_revision_id);

    ep4_display_ecqs (rail);

    ep_display_alloc (&sys->Allocator);
    ep_display_rmap (sys->Allocator.ResourceMap);

    ep_display_alloc (&rail->r_generic.ElanAllocator);
    ep_display_alloc (&rail->r_generic.MainAllocator);

    ep_display_rmap (rail->r_generic.ElanAllocator.ResourceMap);
}

