/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *    Copyright (c) 2002-2003 by Quadrics Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ident "@(#)$Id: epcomms_asm_elan4_thread.S,v 1.5 2004/04/25 11:25:43 david Exp $ $Name: QSNETMODULES-5-11-3_20050907 $"
/*      $Source: /cvs/master/quadrics/epmod/epcomms_asm_elan4_thread.S,v $*/

#include <elan4/events.h>
#include <elan4/commands.h>

#include "assym_elan4.h"

/* XXXXX - registers.h */
#define E4_MAIN_INT_SHIFT		14

/*
 * c_waitevent_interrupt (E4_uint64 *commandport, E4_Event *event, E4_uint64 count, E4_uint64 intcookie)
 */
	.global c_waitevent_interrupt
c_waitevent_interrupt:
	add		%sp, -192, %sp
	st64		%r16, [%sp + 64]		// preserve call preserved registers
	st64		%r24, [%sp + 128]		// - see CALL_USED_REGISTERS.
	mov		%r16,%r16			// BUG FIX: E4 RevA
	mov		%r24,%r24			// BUG FIX: E4 RevA
	nop						// BUG FIX: E4 RevA
	nop						// BUG FIX: E4 RevA

	mov		%r7, %r18			// (%r2) return pc
1:	call		2f
	 mov		%sp, %r17			// (%r1) SP
2:	add		%r7, (3f-1b), %r16		// (%r0) PC
	st32		%r16, [%sp]			// event source block
	mov		MAKE_EXT_CLEAN_CMD, %r23
	st8		%r23, [%sp+56]			// event source block
	mov		%r16,%r16			// BUG FIX: E4 RevA
	mov		%r23,%r23			// BUG FIX: E4 RevA
	nop						// BUG FIX: E4 RevA
	nop						// BUG FIX: E4 RevA
	
	or		%r9, WAIT_EVENT_CMD, %r16						! WAIT_EVENT_CMD | event
	sll8		%r10, 32, %r17
	or		%r17, E4_EVENT_TYPE_VALUE(E4_EVENT_COPY, E4_EVENT_DTYPE_LONG, 8), %r17	!   ev_CountAndType
	mov		%sp, %r18								!   ev_Source
	mov		%r8, %r19								!   ev_Dest
	sll8		%r11, E4_MAIN_INT_SHIFT, %r20
	or		%r20, INTERRUPT_CMD, %r20						! INTERRUPT_CMD | (cookie << E4_MAIN_INT_SHIFT)
	mov		NOP_CMD, %r21
	mov		NOP_CMD, %r22
	mov		NOP_CMD, %r23

	st64suspend	%r16, [%r8]
	
3:	ld64		[%sp + 64], %r16		// restore call preserved register
	ld64		[%sp + 128], %r24
	jmpl		%r2+8, %r0			// and return
	 add		%sp, 192, %sp


#define EP4_RCVR_PENDING_STALLED		1		/* indicates thread has stalled for no descriptor (rcvr_pending_head) */

#define RXD_DEBUG(VAL,RXD,TMP) \
	mov	VAL, TMP; \
	st8	TMP, [RXD + EP4_RXD_DEBUG]

	
	/*
	 * %r2  - rcvr elan
	 * %r3  - rxd elan
	 */
	.global	c_queue_rxd
c_queue_rxd:
	RXD_DEBUG(1, %r3, %r23)
	
	ld16	[%r2 + EP4_RCVR_PENDING_TAILP], %r18	/* r18 == tailp, r19 = head */
	add	%r3, EP4_RXD_NEXT, %r4
	
	st8	%r0, [%r3 + EP4_RXD_NEXT]		/* rxd->rxd_next = NULL */
	st8     %r4, [%r2 + EP4_RCVR_PENDING_TAILP]	/* tailp = &rxd->rxd_next */
	st8	%r3, [%r18]				/* *tailp = rxd */

	cmp	%r19, EP4_RCVR_PENDING_STALLED		/* thread stalled ? */
	beq	1f
	 mov	%r18, %r16				/* must have used %r16, %r19, %r23 */
	mov	%r3, %r23

	RXD_DEBUG(2, %r3, %r23)
	
	st8suspend %r16, [%r3 + EP4_RXD_QUEUED]		/* no - mark as queued - all done */

1:	st8	%r16, [%r3 + EP4_RXD_QUEUED]		/* mark as queued */

	RXD_DEBUG(3, %r3, %r23)

	mov	%r3, %r8				/* return rxd from c_stall_thread */
	ba	.epcomms_resume_thread			/* resume the thread */
	 ld64	[%r2 + EP4_RCVR_THREAD_STALL], %r0

	/*
	 *  c_stall_thread (EP4_RCVR_ELAN *rcvrElan)
	 */
	.global c_stall_thread
c_stall_thread:
	add		%sp, -192, %sp
	st64		%r16, [%sp + 64]		// preserve call preserved registers
	st64		%r24, [%sp + 128]		// - see CALL_USED_REGISTERS.
	mov		%r16,%r16			// BUG FIX: E4 RevA
	mov		%r24,%r24			// BUG FIX: E4 RevA
	nop						// BUG FIX: E4 RevA
	nop						// BUG FIX: E4 RevA

	mov		EP4_RCVR_PENDING_STALLED, %r9	// Mark rcvr as stalled
	st8		%r9, [%r8 + EP4_RCVR_PENDING_HEAD]

	// XXXX _ TBD should generate interrupt

	mov		%r1, %r17			// SP 
	mov		%r7, %r23			// return pc

	st64suspend	%r16, [%r8 + EP4_RCVR_THREAD_STALL]
	
.epcomms_resume_thread:
	/* %r8 == rxdElan */
	
	ld64		[%sp + 64], %r16		// restore call preserved register
	ld64		[%sp + 128], %r24
	jmpl		%r7+8, %r0			// and return
	 add		%sp, 192, %sp

