/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *    Copyright (c) 2002-2003 by Quadrics Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ifndef __EP_KCOMM_VP_H
#define __EP_KCOMM_VP_H

#ident "@(#)$Id: kcomm_vp.h,v 1.2 2004/03/24 11:32:56 david Exp $ $Name: QSNETMODULES-5-11-3_20050907 $"
/*      $Source: /cvs/master/quadrics/epmod/kcomm_vp.h,v $*/

#define EP_MAX_NODES			2048			/* Max nodes we support */

/* virtual process allocation */
#define EP_VP_NODE_BASE			(0)
#define EP_VP_DATA_BASE			(EP_VP_NODE_BASE + EP_MAX_NODES)
#define EP_VP_PROBE_BASE		(EP_VP_DATA_BASE + EP_MAX_NODES)
#define EP_VP_PROBE_COUNT		ELAN_MAX_LEVELS

#define EP_VP_BCAST_BASE		(EP_VP_PROBE_BASE + EP_VP_PROBE_COUNT)
#define EP_VP_BCAST_COUNT		(CM_SGMTS_PER_LEVEL * (CM_MAX_LEVELS - 1) + 1)

#define EP_VP_NODE(nodeId)		(EP_VP_NODE_BASE + (nodeId))
#define EP_VP_DATA(nodeId)		(EP_VP_DATA_BASE + (nodeId))
#define EP_VP_PROBE(lvl)		(EP_VP_PROBE_BASE + (lvl))
#define EP_VP_BCAST(lvl,sgmt)		(EP_VP_BCAST_BASE + ((lvl) - 1)*CM_SGMTS_PER_LEVEL + (sgmt))

#define EP_VP_TO_NODE(vp)		((vp) & (EP_MAX_NODES-1))
#define EP_VP_ISDATA(vp)		((vp) >= EP_VP_DATA_BASE && (vp) < (EP_VP_DATA_BASE + EP_MAX_NODES))

#endif /* __EP_KCOMM_VP_H */


