/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ifndef __JTAGDRV_COMMON_H
#define __JTAGDRV_COMMON_H

#ident "@(#)$Id: jtagdrv.h,v 1.5 2002/08/09 11:18:37 addy Exp $"
/*      $Source: /cvs/master/quadrics/jtagmod/jtagdrv.h,v $*/

#include <qsnet/config.h>

/* include OS specific header file */
#if defined(LINUX)
#  include "jtagdrv_Linux.h"
#elif defined(DIGITAL_UNIX)
#  include "jtagdrv_OSF1.h"
#elif defined(QNX)
#  include "jtagdrv_QNX.h"
#else
#  error cannot determint os type
#endif

extern int jtagdebug;

#define DBG_CFG		(1 << 0)
#define DBG_OPEN	(1 << 1)
#define DBG_IOCTL	(1 << 2)
#define DBG_ECPP	(1 << 3)
#define DBG_FN		(1 << 4)

#define DRIVER_NAME    "jtag"

#if defined(LINUX)
#define PRINTF(n,X)	((n) & jtagdebug ? (void) printk X : (void) 0)
#define PRINTMSG(fmt, arg...) printk(KERN_INFO DRIVER_NAME ": " fmt, ##arg)
#else
#define PRINTF(n,X)	((n) & jtagdebug ? (void) printf X : (void) 0)
#define PRINTMSG(M, A)	printf ("jtag: " M, A)
#endif

extern void jtagdrv_select_ring (JTAG_DEV *pp, u_int ring);
extern void jtagdrv_reset (JTAG_DEV *pp);
extern void jtagdrv_shift_ir (JTAG_DEV *pp, u_char *value, int nbits);
extern void jtagdrv_shift_dr (JTAG_DEV *pp, u_char *value, int nbits);

extern int  jtagdrv_i2c_write (JTAG_DEV *pp, u_int address, u_int count, u_char *data);
extern int  jtagdrv_i2c_read (JTAG_DEV *pp, u_int address, u_int count, u_char *data);
extern int  jtagdrv_i2c_writereg (JTAG_DEV *pp, u_int address, u_int intaddress, u_int count, u_char *data);
extern int  jtagdrv_i2c_readreg (JTAG_DEV *pp, u_int address, u_int intaddress, u_int count, u_char *data);
extern void jtagdrv_i2c_clock_shift (JTAG_DEV *pp, u_int t, u_int n, u_int m);


#endif /* __JTAGDRV_COMMON_H */
