/*
 *    Copyright (c) 2003 by Quadrics Limited.
 * 
 *    For licensing information please see the supplied COPYING file
 *
 */

#ident "@(#)$Id: device.h,v 1.5 2003/09/24 13:55:37 david Exp $"
/*      $Source: /cvs/master/quadrics/elanmod/modsrc/device.h,v $*/

#ifndef __ELAN_DEVICE_H
#define __ELAN_DEVICE_H

/* non-kernel headings */
typedef unsigned int ELAN_DEV_IDX;

#if defined(__KERNEL__)

/* device callbacks */
#define ELAN_DEV_OPS_VERSION ((u_int)1)

typedef struct elan_dev_ops
{
	/* dev info */
	int (*get_position)          (void *user_data, ELAN_POSITION *position);
	int (*set_position)          (void *user_data, unsigned short nodeId, unsigned short numNodes);

	/* cap */

	u_int  ops_version;
} ELAN_DEV_OPS;

typedef struct elan_dev_struct
{
	struct list_head node;

	ELAN_DEV_IDX     devidx;
	ELAN_DEVINFO    *devinfo;
	void            *user_data;
	ELAN_DEV_OPS *ops;
} ELAN_DEV_STRUCT;

/* device.c */
extern ELAN_DEV_IDX         elan_dev_register   (ELAN_DEVINFO    *devinfo, 
						    ELAN_DEV_OPS *ops,
						    void            *userdata);
extern int                  elan_dev_deregister (ELAN_DEVINFO *devinfo);

extern ELAN_DEV_STRUCT * elan_dev_find       (ELAN_DEV_IDX devidx);

extern ELAN_DEV_STRUCT * elan_dev_find_byrail(unsigned short deviceid, unsigned rail);
extern int                  elan_dev_dump       (void);

#endif /* __KERNEL__ */

#endif /* __ELAN_DEVICE_H */

/*
 * Local variables:
 * c-file-style: "linux"
 * End:
 */
