/*
 *    Copyright (c) 2003 by Quadrics Ltd.
 * 
 *    For licensing information please see the supplied COPYING file
 *
 */

#ident "@(#)$Id: elanmod_linux.h,v 1.7 2005/02/22 12:29:22 addy Exp $"
/*      $Source: /cvs/master/quadrics/elanmod/modsrc/elanmod_linux.h,v $*/

#ifndef __ELAN_MOD_LINUX_H
#define __ELAN_MOD_LINUX_H

#define ELANCRTL_USER_BASE		0x40

/* stats */
typedef struct elanctrl_stats_get_next_struct
{
	ELAN_STATS_IDX   statidx; 
	ELAN_STATS_IDX  *next_statidx; /* return value */
} ELANCTRL_STATS_GET_NEXT_STRUCT;
#define ELANCTRL_STATS_GET_NEXT   _IOR   ('e', ELANCRTL_USER_BASE + 0,  ELANCTRL_STATS_GET_NEXT_STRUCT)

typedef struct elanctrl_stats_find_index_struct
{
	caddr_t          block_name;
	ELAN_STATS_IDX  *statidx; /* return value */
	uint        *num_entries; /* return value */
} ELANCTRL_STATS_FIND_INDEX_STRUCT;
#define ELANCTRL_STATS_FIND_INDEX   _IOR   ('e', ELANCRTL_USER_BASE + 1,  ELANCTRL_STATS_FIND_INDEX_STRUCT)

typedef struct elanctrl_stats_get_block_info_struct
{
	ELAN_STATS_IDX  statidx; 
	caddr_t       block_name; /* return value */
	uint        *num_entries; /* return value */
} ELANCTRL_STATS_GET_BLOCK_INFO_STRUCT;
#define ELANCTRL_STATS_GET_BLOCK_INFO   _IOR   ('e', ELANCRTL_USER_BASE + 2, ELANCTRL_STATS_GET_BLOCK_INFO_STRUCT)

typedef struct elanctrl_stats_get_index_name_struct
{
	ELAN_STATS_IDX statidx; 
	uint           index;
	caddr_t        name; /* return value */
} ELANCTRL_STATS_GET_INDEX_NAME_STRUCT;
#define ELANCTRL_STATS_GET_INDEX_NAME   _IOR   ('e', ELANCRTL_USER_BASE + 3, ELANCTRL_STATS_GET_INDEX_NAME_STRUCT)

typedef struct elanctrl_stats_clear_block_struct
{
	ELAN_STATS_IDX statidx; 
} ELANCTRL_STATS_CLEAR_BLOCK_STRUCT;
#define ELANCTRL_STATS_CLEAR_BLOCK   _IOR   ('e', ELANCRTL_USER_BASE + 4, ELANCTRL_STATS_CLEAR_BLOCK_STRUCT)

typedef struct elanctrl_stats_get_block_struct
{
	ELAN_STATS_IDX statidx; 
	uint           entries;  
	ulong         *values; /* return values */
} ELANCTRL_STATS_GET_BLOCK_STRUCT;
#define ELANCTRL_STATS_GET_BLOCK        _IOR   ('e', ELANCRTL_USER_BASE + 5, ELANCTRL_STATS_GET_BLOCK_STRUCT)


typedef struct elanctrl_get_devinfo_struct
{
	ELAN_DEV_IDX  devidx; 
	ELAN_DEVINFO *devinfo; /* return values */
} ELANCTRL_GET_DEVINFO_STRUCT;
#define ELANCTRL_GET_DEVINFO        _IOR   ('e', ELANCRTL_USER_BASE + 6, ELANCTRL_GET_DEVINFO_STRUCT)

typedef struct elanctrl_get_position_struct
{
	ELAN_DEV_IDX   devidx; 
	ELAN_POSITION *position; /* return values */
} ELANCTRL_GET_POSITION_STRUCT;
#define ELANCTRL_GET_POSITION        _IOR   ('e', ELANCRTL_USER_BASE + 7, ELANCTRL_GET_POSITION_STRUCT)

typedef struct elanctrl_set_position_struct
{
	ELAN_DEV_IDX   devidx; 
	unsigned short nodeId;
	unsigned short numNodes;
} ELANCTRL_SET_POSITION_STRUCT;
#define ELANCTRL_SET_POSITION        _IOR   ('e', ELANCRTL_USER_BASE + 8, ELANCTRL_SET_POSITION_STRUCT)

typedef struct elanctrl_create_cap_struct
{
	ELAN_CAPABILITY cap;
} ELANCTRL_CREATE_CAP_STRUCT;
#define ELANCTRL_CREATE_CAP             _IOW   ('e', ELANCRTL_USER_BASE + 9, ELANCTRL_CREATE_CAP_STRUCT)

typedef struct elanctrl_destroy_cap_struct
{
	ELAN_CAPABILITY cap;
} ELANCTRL_DESTROY_CAP_STRUCT;
#define ELANCTRL_DESTROY_CAP             _IOW   ('e', ELANCRTL_USER_BASE + 10, ELANCTRL_DESTROY_CAP_STRUCT)

typedef struct elanctrl_create_vp_struct
{
	ELAN_CAPABILITY cap;
	ELAN_CAPABILITY map;
} ELANCTRL_CREATE_VP_STRUCT;
#define ELANCTRL_CREATE_VP             _IOW   ('e', ELANCRTL_USER_BASE + 11, ELANCTRL_CREATE_VP_STRUCT)

typedef struct elanctrl_destroy_vp_struct
{
	ELAN_CAPABILITY cap;
	ELAN_CAPABILITY map;
} ELANCTRL_DESTROY_VP_STRUCT;
#define ELANCTRL_DESTROY_VP          _IOW   ('e', ELANCRTL_USER_BASE + 12, ELANCTRL_DESTROY_VP_STRUCT)

#define ELANCTRL_DEBUG_DUMP          _IO    ('e', ELANCRTL_USER_BASE + 13)

typedef struct elanctrl_get_caps_struct
{
	uint            *number_of_results;
	uint             array_size;
	ELAN_CAP_STRUCT *caps;
} ELANCTRL_GET_CAPS_STRUCT;
#define ELANCTRL_GET_CAPS          _IOW   ('e', ELANCRTL_USER_BASE + 14, ELANCTRL_GET_CAPS_STRUCT)


typedef struct elanctrl_debug_buffer_struct
{
	caddr_t buffer;
	int     size;
} ELANCTRL_DEBUG_BUFFER_STRUCT;
#define ELANCTRL_DEBUG_BUFFER _IOW ('e', ELANCRTL_USER_BASE + 15, ELANCTRL_DEBUG_BUFFER_STRUCT)


/*
 * Usercopy ioctl definitions
 */
typedef struct elanctrl_usercopy_attach_struct
{
	ELAN_CAPABILITY cap;	/* process capability (for security checks) */
} ELANCTRL_USERCOPY_ATTACH_STRUCT;
#define ELANCTRL_USERCOPY_ATTACH      _IOR ('u', ELANCRTL_USER_BASE + 0, ELANCTRL_USERCOPY_ATTACH_STRUCT)
#define ELANCTRL_USERCOPY_DETACH      _IO  ('u', ELANCRTL_USER_BASE + 1)

typedef struct elanctrl_usercopy_struct
{
	void *remote;		/* remote process buffer */
	void *local;		/* local process buffer */
	size_t len;
	int   write;		/* Direction */

	int   ctxId;		/* remote process context id (0 .. nlocal-1) */

} ELANCTRL_USERCOPY_STRUCT;
#define ELANCTRL_USERCOPY             _IOR ('u', ELANCRTL_USER_BASE + 2, ELANCTRL_USERCOPY_STRUCT)

#define ELANMOD_PROCFS_IOCTL      "/proc/qsnet/elan/ioctl"
#define ELANMOD_PROCFS_USER_IOCTL "/proc/qsnet/elan/user"
#define ELANMOD_PROCFS_VERSION    "/proc/qsnet/elan/version"
#define ELANMOD_PROCFS_DEBUG_MASK "/proc/qsnet/elan/debug_mask"
#define ELANMOD_PROCFS_DEBUG_MODE "/proc/qsnet/elan/debug_mode"

#endif /* __ELAN_MOD_LINUX_H */

/*
 * Local variables:
 * c-file-style: "linux"
 * End:
 */
