/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ifndef _ELAN_DEBUG_H
#define _ELAN_DEBUG_H


#ident "$Id: elanmoddebug.h,v 1.6 2005/05/24 17:07:44 addy Exp $"
/*      $Source: /cvs/master/quadrics/elanmod/modsrc/elanmoddebug.h,v $ */

#if defined(__KERNEL__)

/* 0 | QSNET_DEBUG_BUFFER | QSNET_DEBUG_CONSOLE */
extern int elan_debug_mode; 
extern int elan_debug_mask;

#define ELAN_DBG_VP		0x00000001
#define ELAN_DBG_CAP            0x00000002
#define ELAN_DBG_CTRL           0x00000004
#define ELAN_DBG_SYS_FN         0x00000008
#define ELAN_DBG_USERCOPY	0x00000010
#define ELAN_DBG_ALL		0xffffffff


#if defined(DEBUG_PRINTF)
#  define ELAN_DEBUG0(m,fmt)	 		((elan_debug_mask&(m)) ? qsnet_debugf(elan_debug_mode,fmt)             : (void)0)
#  define ELAN_DEBUG1(m,fmt,a)			((elan_debug_mask&(m)) ? qsnet_debugf(elan_debug_mode,fmt,a)           : (void)0)
#  define ELAN_DEBUG2(m,fmt,a,b)		((elan_debug_mask&(m)) ? qsnet_debugf(elan_debug_mode,fmt,a,b)         : (void)0)
#  define ELAN_DEBUG3(m,fmt,a,b,c)		((elan_debug_mask&(m)) ? qsnet_debugf(elan_debug_mode,fmt,a,b,c)       : (void)0)
#  define ELAN_DEBUG4(m,fmt,a,b,c,d)		((elan_debug_mask&(m)) ? qsnet_debugf(elan_debug_mode,fmt,a,b,c,d)     : (void)0)
#  define ELAN_DEBUG5(m,fmt,a,b,c,d,e)		((elan_debug_mask&(m)) ? qsnet_debugf(elan_debug_mode,fmt,a,b,c,d,e)   : (void)0)
#  define ELAN_DEBUG6(m,fmt,a,b,c,d,e,f)	((elan_debug_mask&(m)) ? qsnet_debugf(elan_debug_mode,fmt,a,b,c,d,e,f) : (void)0)
#ifdef __GNUC__
#  define ELAN_DEBUG(m,args...)			((elan_debug_mask&(m)) ? qsnet_debugf(elan_debug_mode, ##args)         : (void)0)
#endif

#else

#  define ELAN_DEBUG0(m,fmt)			(0)
#  define ELAN_DEBUG1(m,fmt,a)			(0)
#  define ELAN_DEBUG2(m,fmt,a,b)		(0)
#  define ELAN_DEBUG3(m,fmt,a,b,c)		(0)
#  define ELAN_DEBUG4(m,fmt,a,b,c,d)		(0)
#  define ELAN_DEBUG5(m,fmt,a,b,c,d,e)		(0)
#  define ELAN_DEBUG6(m,fmt,a,b,c,d,e,f)	(0)
#ifdef __GNUC__
#  define ELAN_DEBUG(m,args...)
#endif

#endif /* DEBUG_PRINTF */


#endif /* __KERNEL__ */
#endif /* _ELAN_DEBUG_H */

/*
 * Local variables:
 * c-file-style: "linux"
 * End:
 */
