/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ifndef __ELAN_KMAP_H
#define __ELAN_KMAP_H

#ident "$Id: kmap.h,v 1.4 2004/12/14 10:19:23 mike Exp $"
/*      $Source: /cvs/master/quadrics/epmod/kmap.h,v $ */

#include <elan/rmap.h>

extern void ep_perrail_kaddr_map (EP_RAIL *rail, EP_ADDR eaddr, virtaddr_t vaddr, unsigned long len, unsigned int perm, int ep_attr);
extern void ep_perrail_sdram_map (EP_RAIL *rail, EP_ADDR eaddr, sdramaddr_t saddr, unsigned long len, unsigned int perm, int ep_attr);
extern void ep_perrail_unmap (EP_RAIL *rail, EP_ADDR eaddr, unsigned long len);
extern void ep_perrail_dvma_sync (EP_RAIL *rail);

typedef struct ep_dvma_nmh
{
    EP_NMH		dvma_nmh;
    
    struct list_head	dvma_link;				/* chained on ep_dvma_state */
    unsigned		dvma_perm;				/* permissions for region */

    spinlock_t		dvma_lock;
    EP_RAILMASK		dvma_railmask;				/* bitmap of rails */
    EP_RAIL	       *dvma_rails[EP_MAX_RAILS];		/* assoicated rails */
    void	       *dvma_private[EP_MAX_RAILS];		/* pointers to rail private data */
    unsigned int        dvma_attrs[1];				/* bitmap of which rails pages are loaded NOTE - max 32 rails */
} EP_DVMA_NMH;

/* values for dvma_perm */
#define EP_PERM_EXECUTE		0
#define EP_PERM_READ		1
#define EP_PERM_WRITE		2
#define EP_PERM_ALL		3

typedef struct ep_dvma_state
{
    kmutex_t		dvma_lock;
    struct list_head    dvma_handles;
    struct list_head    dvma_rails;
    EP_RMAP	       *dvma_rmap;
} EP_DVMA_STATE;

extern void    ep_dvma_init (EP_SYS *sys);
extern void    ep_dvma_fini (EP_SYS *sys);
extern EP_NMH *ep_dvma_reserve (EP_SYS *sys, unsigned npages, unsigned perm);
extern void    ep_dvma_release (EP_SYS *sys, EP_NMH *nmh);
extern void    ep_dvma_load (EP_SYS *sys, void *map, caddr_t vaddr, unsigned len, 
			     EP_NMH *nmh, unsigned index, EP_RAILMASK *hints, EP_NMD *subset);
extern void    ep_dvma_unload (EP_SYS *sys, EP_NMH *nmh, EP_NMD *nmd);
  
extern void    ep_dvma_remove_rail (EP_SYS *sys, EP_RAIL *rail);
extern int     ep_dvma_add_rail (EP_SYS *sys, EP_RAIL *rail);

extern uint16_t rolling_check_sum (char *msg, int nob, uint16_t sum);

#endif /* __ELAN_KMAP_H */

/*
 * Local variables:
 * c-file-style: "stroustrup"
 * End:
 */
