/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *    Copyright (c) 2002-2003 by Quadrics Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ifndef __ELAN3_KTHREAD_H
#define __ELAN3_KTHREAD_H

#ident "@(#)$Id: kthread.h,v 1.4 2004/05/06 14:24:08 david Exp $ $Name: QSNETMODULES-5-11-3_20050907 $"
/*      $Source: /cvs/master/quadrics/epmod/kthread.h,v $*/

typedef struct ep_kthread
{
	kcondvar_t	wait;					/* place to sleep */
	spinlock_t	lock;					/* and lock */
	long		next_run;				/* tick when thread should next run */
	long		running;				/* tick when thread started to run */
	unsigned short  should_stall;
	unsigned char   state;
	unsigned int    started:1;
	unsigned int    should_stop:1;
	unsigned int	stopped:1;
} EP_KTHREAD;

#define KT_STATE_SLEEPING		0
#define KT_STATE_SCHEDULED		1
#define KT_STATE_RUNNING		2
#define KT_STATE_STALLED		3

#define AFTER(a, b)			((((long)(a)) - ((long)(b))) > 0)
#define BEFORE(a,b)			((((long)(a)) - ((long)(b))) < 0)

extern void ep_kthread_init (EP_KTHREAD *kt);
extern void ep_kthread_destroy (EP_KTHREAD *kt);
extern void ep_kthread_started (EP_KTHREAD *kt);
extern void ep_kthread_stopped (EP_KTHREAD *kt);
extern int  ep_kthread_should_stall (EP_KTHREAD *kth);
extern int  ep_kthread_sleep (EP_KTHREAD *kth, long next_run);
extern void ep_kthread_schedule (EP_KTHREAD *kt, long when);
extern void ep_kthread_stall (EP_KTHREAD *kth);
extern void ep_kthread_resume (EP_KTHREAD *kt);
extern void ep_kthread_stop (EP_KTHREAD *kt);
extern int  ep_kthread_state (EP_KTHREAD *kt, long *time);
#endif /* __ELAN3_KTHREAD_H */

/*
 * Local variables:
 * c-file-style: "linux"
 * End:
 */
