/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *    Copyright (c) 2002-2003 by Quadrics Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ifndef __ELAN_RMAP_H
#define __ELAN_RMAP_H

#ident "$Id: rmap.h,v 1.8 2004/05/19 10:24:40 david Exp $"
/*      $Source: /cvs/master/quadrics/epmod/rmap.h,v $ */


typedef struct ep_rmap_entry 
{
    size_t	m_size;
    u_long	m_addr;
} EP_RMAP_ENTRY;

typedef struct ep_rmap 
{
    spinlock_t	     m_lock;
    kcondvar_t       m_wait;
    u_int	     m_size;
    u_int	     m_free;
    u_int	     m_want;
    char            *m_name;
    EP_RMAP_ENTRY    m_map[1];
} EP_RMAP;

extern void	     ep_display_rmap (EP_RMAP *map);

extern void          ep_rmapinit (EP_RMAP *rmap, char *name, u_int mapsize);
extern unsigned long ep_rmalloc (EP_RMAP *rmap, size_t size, int cansleep);
extern unsigned long ep_rmalloc_constrained (EP_RMAP *mp, size_t size, unsigned long alo, unsigned long ahi, unsigned long align, int cansleep);
extern void          ep_rmfree (EP_RMAP *rmap, size_t size, unsigned long addr);
extern unsigned long ep_rmget (EP_RMAP *rmap, size_t size, unsigned long addr);
extern EP_RMAP      *ep_rmallocmap (size_t size, char *name, int cansleep);
extern void          ep_rmfreemap (EP_RMAP *map);

#endif /* __ELAN3_RMAP_H */

/*
 * Local variables:
 * c-file-style: "stroustrup"
 * End:
 */
