/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *    Copyright (c) 2002-2003 by Quadrics Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ifndef __ELAN_STATEMAP_H
#define __ELAN_STATEMAP_H

#ident "$Id: statemap.h,v 1.8 2003/10/07 13:22:38 david Exp $"
/*      $Source: /cvs/master/quadrics/epmod/statemap.h,v $ */

#include <elan/bitmap.h>

/******************************** global state bitmap stuff **********************************/
typedef struct
{
   unsigned int size;
   unsigned int nob;
   unsigned int changemap_nob;
   unsigned int bitmap_nob;
   bitmap_t    *changemap0;
   bitmap_t    *changemap1;
   bitmap_t    *changemap2;
   bitmap_t    *bitmap;
} statemap_t;

extern bitmap_t	      statemap_getseg (statemap_t *map, unsigned int offset);
extern void           statemap_setseg (statemap_t *map, unsigned int offset, bitmap_t seg);
extern bitmap_t       statemap_getbits (statemap_t *map, unsigned int offset, int nbits);
extern void           statemap_setbits (statemap_t *map, unsigned int offset, bitmap_t bits, int nbits);
extern void           statemap_zero (statemap_t *map);
extern void           statemap_setmap (statemap_t *dst, statemap_t *src);
extern void           statemap_ormap (statemap_t *dst, statemap_t *src);
extern int	      statemap_findchange (statemap_t *map, bitmap_t *newseg, int clearchange);
extern int            statemap_changed (statemap_t *map);
extern void           statemap_reset (statemap_t *map);
extern void           statemap_copy (statemap_t *dst, statemap_t *src);
extern void           statemap_clearchanges (statemap_t *map);
extern bitmap_t      *statemap_tobitmap (statemap_t *map);
extern statemap_t    *statemap_create (int size);
extern void           statemap_destroy (statemap_t *map);

#endif /* __ELAN_STATEMAP_H */

/*
 * Local variables:
 * c-file-style: "stroustrup"
 * End:
 */
