/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *    Copyright (c) 2002-2003 by Quadrics Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ident "@(#)$Id: compat.h,v 1.4 2004/06/09 09:07:03 mike Exp $ $Name: QSNETMODULES-5-11-3_20050907 $"
/*      $Source: /cvs/master/quadrics/elan3mod/elan3/elan3/compat.h,v $*/

#ifndef __ELAN3_COMPAT_H
#define __ELAN3_COMPAT_H

/* compatibility header to allow Eagle branch QSNETLIBS 
 * to compile against head kernel */

#define ELAN_EAGLE_COMPAT

/* vmseg.h */
#define ELAN_FLAGSTATS				ELAN3_FLAGSTATS

/* uregs.h */
#define ELAN_STATS_NAME				ELAN3_STATS_NAME
#define elan3_stats_names			elan_stats_names

/* spinlock.h */
#define ELAN_SPINLOCK				ELAN3_SPINLOCK
#define ELAN_SPINLOCK_MAIN			ELAN3_SPINLOCK_MAIN
#define ELAN_SPINLOCK_ELAN			ELAN3_SPINLOCK_ELAN
#define ELAN_ME_SPINENTER			ELAN3_ME_SPINENTER
#define ELAN_ME_FORCEENTER			ELAN3_ME_FORCEENTER
#define ELAN_ME_SPINEXIT			ELAN3_ME_SPINEXIT
#define ELAN_SPINENTER				ELAN3_SPINENTER
#define ELAN_SPINEXIT				ELAN3_SPINEXIT
#define elan3_me_spinblock			elan_me_spinblock
#define elan3_spinenter				elan_spinenter

/* elanio.h */
#define ELANIO_CONTROL_PATHNAME			ELAN3IO_CONTROL_PATHNAME
#define ELANIO_USER_PATHNAME			ELAN3IO_USER_PATHNAME
#define ELANIO_SDRAM_PATHNAME			ELAN3IO_SDRAM_PATHNAME
#define ELANIO_MAX_PATHNAMELEN			ELAN3IO_MAX_PATHNAMELEN

#define ELANIO_SET_BOUNDARY_SCAN		ELAN3IO_SET_BOUNDARY_SCAN
#define ELANIO_CLEAR_BOUNDARY_SCAN		ELAN3IO_CLEAR_BOUNDARY_SCAN
#define ELANIO_READ_LINKVAL			ELAN3IO_READ_LINKVAL
#define ELANIO_WRITE_LINKVAL			ELAN3IO_WRITE_LINKVAL
#define ELANIO_SET_DEBUG_STRUCT			ELAN3IO_SET_DEBUG_STRUCT
#define ELANIO_SET_DEBUG			ELAN3IO_SET_DEBUG
#define ELANIO_DEBUG_BUFFER_STRUCT		ELAN3IO_DEBUG_BUFFER_STRUCT
#define ELANIO_DEBUG_BUFFER			ELAN3IO_DEBUG_BUFFER
#define ELANIO_NETERR_SERVER_STRUCT		ELAN3IO_NETERR_SERVER_STRUCT
#define ELANIO_NETERR_SERVER			ELAN3IO_NETERR_SERVER
#define ELANIO_NETERR_FIXUP			ELAN3IO_NETERR_FIXUP

#define ELANIO_FREE				ELAN3IO_FREE
#define ELANIO_ATTACH				ELAN3IO_ATTACH
#define ELANIO_DETACH				ELAN3IO_DETACH
#define ELANIO_ADDVP_STRUCT			ELAN3IO_ADDVP_STRUCT
#define ELANIO_ADDVP				ELAN3IO_ADDVP
#define ELANIO_REMOVEVP				ELAN3IO_REMOVEVP
#define ELANIO_BCASTVP_STRUCT			ELAN3IO_BCASTVP_STRUCT
#define ELANIO_BCASTVP				ELAN3IO_BCASTVP
#define ELANIO_LOAD_ROUTE_STRUCT		ELAN3IO_LOAD_ROUTE_STRUCT
#define ELANIO_LOAD_ROUTE			ELAN3IO_LOAD_ROUTE
#define ELANIO_PROCESS				ELAN3IO_PROCESS
#define ELANIO_SETPERM_STRUCT			ELAN3IO_SETPERM_STRUCT
#define ELANIO_SETPERM				ELAN3IO_SETPERM
#define ELANIO_CLEARPERM_STRUCT			ELAN3IO_CLEARPERM_STRUCT
#define ELANIO_CLEARPERM			ELAN3IO_CLEARPERM
#define ELANIO_CHANGEPERM_STRUCT		ELAN3IO_CHANGEPERM_STRUCT
#define ELANIO_CHANGEPERM			ELAN3IO_CHANGEPERM
#define ELANIO_HELPER_THREAD			ELAN3IO_HELPER_THREAD
#define ELANIO_WAITCOMMAND			ELAN3IO_WAITCOMMAND
#define ELANIO_BLOCK_INPUTTER			ELAN3IO_BLOCK_INPUTTER
#define ELANIO_SET_FLAGS			ELAN3IO_SET_FLAGS
#define ELANIO_WAITEVENT			ELAN3IO_WAITEVENT
#define ELANIO_ALLOC_EVENTCOOKIE		ELAN3IO_ALLOC_EVENTCOOKIE
#define ELANIO_FREE_EVENTCOOKIE			ELAN3IO_FREE_EVENTCOOKIE
#define ELANIO_ARM_EVENTCOOKIE			ELAN3IO_ARM_EVENTCOOKIE
#define ELANIO_WAIT_EVENTCOOKIE			ELAN3IO_WAIT_EVENTCOOKIE
#define ELANIO_SWAPSPACE			ELAN3IO_SWAPSPACE
#define ELANIO_EXCEPTION_SPACE			ELAN3IO_EXCEPTION_SPACE
#define ELANIO_GET_EXCEPTION			ELAN3IO_GET_EXCEPTION
#define ELANIO_UNLOAD_STRUCT			ELAN3IO_UNLOAD_STRUCT
#define ELANIO_UNLOAD				ELAN3IO_UNLOAD
#define ELANIO_GET_ROUTE_STRUCT			ELAN3IO_GET_ROUTE_STRUCT
#define ELANIO_GET_ROUTE			ELAN3IO_GET_ROUTE
#define ELANIO_RESET_ROUTE_STRUCT		ELAN3IO_RESET_ROUTE_STRUCT
#define ELANIO_RESET_ROUTE			ELAN3IO_RESET_ROUTE
#define ELANIO_CHECK_ROUTE_STRUCT		ELAN3IO_CHECK_ROUTE_STRUCT
#define ELANIO_CHECK_ROUTE			ELAN3IO_CHECK_ROUTE
#define ELANIO_VP2NODEID_STRUCT			ELAN3IO_VP2NODEID_STRUCT
#define ELANIO_VP2NODEID			ELAN3IO_VP2NODEID
#define ELANIO_SET_SIGNAL			ELAN3IO_SET_SIGNAL
#define ELANIO_PROCESS_2_LOCATION_STRUCT	ELAN3IO_PROCESS_2_LOCATION_STRUCT
#define ELANIO_PROCESS_2_LOCATION		ELAN3IO_PROCESS_2_LOCATION
#define ELANIO_GET_DEVINFO_STRUCT		ELAN3IO_GET_DEVINFO_STRUCT
#define ELANIO_GET_DEVINFO			ELAN3IO_GET_DEVINFO
#define ELANIO_GET_POSITION_STRUCT		ELAN3IO_GET_POSITION_STRUCT
#define ELANIO_GET_POSITION			ELAN3IO_GET_POSITION
#define ELANIO_STATS_STRUCT			ELAN3IO_STATS_STRUCT
#define ELANIO_STATS				ELAN3IO_STATS
#  define ELAN_SYS_STATS_DEVICE			ELAN3_SYS_STATS_DEVICE
#  define ELAN_SYS_STATS_ELAN3MMU		ELAN3_SYS_STATS_MMU

#define ELANIO_OFF_FLAG_PAGE			ELAN3IO_OFF_FLAG_PAGE
#define ELANIO_OFF_UREG_PAGE			ELAN3IO_OFF_UREG_PAGE
#define ELANIO_OFF_COMMAND_PAGE			ELAN3IO_OFF_COMMAND_PAGE


/* elanvp.h */
#define ELAN_ROUTE_SUCCESS			ELAN3_ROUTE_SUCCESS
#define ELAN_ROUTE_SYSCALL_FAILED		ELAN3_ROUTE_SYSCALL_FAILED
#define ELAN_ROUTE_INVALID			ELAN3_ROUTE_INVALID
#define ELAN_ROUTE_TOO_LONG			ELAN3_ROUTE_TOO_LONG
#define ELAN_ROUTE_LOAD_FAILED			ELAN3_ROUTE_LOAD_FAILED
#define ELAN_ROUTE_PROC_RANGE			ELAN3_ROUTE_PROC_RANGE
#define ELAN_ROUTE_INVALID_LEVEL		ELAN3_ROUTE_INVALID_LEVEL
#define ELAN_ROUTE_OCILATES			ELAN3_ROUTE_OCILATES
#define ELAN_ROUTE_WRONG_DEST			ELAN3_ROUTE_WRONG_DEST
#define ELAN_ROUTE_TURN_LEVEL			ELAN3_ROUTE_TURN_LEVEL
#define ELAN_ROUTE_NODEID_UNKNOWN		ELAN3_ROUTE_NODEID_UNKNOWN

/* elandev.h */
#define ELAN_STATS				ELAN3_STATS
#define ELAN_STATS_VERSION			ELAN3_STATS_VERSION

/* perm.h */
#define ELAN_PERM_NOREMOTE			ELAN3_PERM_NOREMOTE
#define ELAN_PERM_LOCAL_READ			ELAN3_PERM_LOCAL_READ
#define ELAN_PERM_REMOTEALL			ELAN3_PERM_REMOTEALL

/* threadsyscall.h */
#define ELAN_ABORT_TRAPNUM			ELAN3_ABORT_TRAPNUM
#define ELAN_ELANCALL_TRAPNUM			ELAN3_ELANCALL_TRAPNUM
#define ELAN_SYSCALL_TRAPNUM			ELAN3_SYSCALL_TRAPNUM
#define ELAN_SYS_close				ELAN3_SYS_close
#define ELAN_SYS_getpid				ELAN3_SYS_getpid
#define ELAN_SYS_ioctl				ELAN3_SYS_ioctl
#define ELAN_SYS_kill				ELAN3_SYS_kill
#define ELAN_SYS_lseek				ELAN3_SYS_lseek
#define ELAN_SYS_mmap				ELAN3_SYS_mmap
#define ELAN_SYS_munmap				ELAN3_SYS_munmap
#define ELAN_SYS_open				ELAN3_SYS_open
#define ELAN_SYS_poll				ELAN3_SYS_poll
#define ELAN_SYS_read				ELAN3_SYS_read
#define ELAN_SYS_write				ELAN3_SYS_write
#define ELAN_T_SYSCALL_CODE			ELAN3_T_SYSCALL_CODE
#define ELAN_T_SYSCALL_ERRNO			ELAN3_T_SYSCALL_ERRNO

/* elansyscall.h */
#define ELAN_SYS_FLAG_DMA_BADVP			ELAN3_SYS_FLAG_DMA_BADVP
#define ELAN_SYS_FLAG_THREAD_BADVP		ELAN3_SYS_FLAG_THREAD_BADVP
#define ELAN_SYS_FLAG_DMAFAIL			ELAN3_SYS_FLAG_DMAFAIL
#define ELAN_SYS_FLAG_NETERR			ELAN3_SYS_FLAG_NETERR

/* intrinsics.h */
#define elan_copy64w				elan3_copy64w
#define elan_read64dw				elan3_read64dw
#define elan_write64dw				elan3_write64dw

#ifndef ELAN_POLL_EVENT
#define ELAN_POLL_EVENT				ELAN3_POLL_EVENT
#endif
#ifndef ELAN_WAIT_EVENT
#define ELAN_WAIT_EVENT				ELAN3_WAIT_EVENT
#endif

#endif /* __ELAN3_COMPAT_H */
/*
 * Local variables:
 * c-file-style: "stroustrup"
 * End:
 */

