/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ifndef __ELAN3_E3TYPES_H
#define __ELAN3_E3TYPES_H

#ident "$Id: e3types.h,v 1.18 2002/08/09 11:23:33 addy Exp $"
/*      $Source: /cvs/master/quadrics/elan3mod/elan3/elan3/e3types.h,v $ */

#include <qsnet/config.h>
/*
 * "flip" values for correctly indexing into
 * block data which was copied from the Elan
 * using 64 bit accesses.
 */
#if defined(__LITTLE_ENDIAN__)
#  define ByteEndianFlip  0
#  define ShortEndianFlip 0
#  define WordEndianFlip  0
#else
#  define ByteEndianFlip  7
#  define ShortEndianFlip 3
#  define WordEndianFlip  1
#endif


#ifndef _ASM

typedef signed int   	   E3_int;
typedef unsigned int   	   E3_uint;

typedef signed char 	   E3_int8;
typedef unsigned char 	   E3_uint8;

typedef signed short 	   E3_int16;
typedef unsigned short 	   E3_uint16;

typedef signed int   	   E3_int32;
typedef unsigned int   	   E3_uint32;

#ifdef __ELAN3__
typedef signed long long   E3_int64;
typedef unsigned long long E3_uint64;
#ifdef _MAIN_LP64
/* NOTE: If the Main is 64-bit we declare the Elan thread's
 * E3_uintptr to be 64-bits too
 */
typedef unsigned long long E3_uintptr;
#else
typedef unsigned long      E3_uintptr;
#endif

#else

#ifdef _LP64
typedef signed long        E3_int64;
typedef unsigned long      E3_uint64;
typedef unsigned long      E3_uintptr;
#else /* _ILP32 */
typedef signed long long   E3_int64;
typedef unsigned long long E3_uint64;
typedef unsigned long      E3_uintptr;
#endif

#endif /* __ELAN3__ */

/* 32-bit Elan3 address */
typedef E3_uint32	   E3_Addr;

#endif /* _ASM */

#endif /* __ELAN3_E3TYPES_H */

/*
 * Local variables:
 * c-file-style: "stroustrup"
 * End:
 */
