/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ifndef __ELAN3_MMU_LINUX_H
#define __ELAN3_MMU_LINUX_H

#ident "$Id: elan3mmu_linux.h,v 1.12 2003/09/24 13:57:24 david Exp $"
/*      $Source: /cvs/master/quadrics/elan3mod/elan3/elan3/elan3mmu_linux.h,v $*/

/* XXX copy of elan3mmu_dunix.h */

#define ALLOC_ELAN3MMU(ptr,cansleep)		KMEM_ALLOC(ptr, ELAN3MMU *, sizeof (ELAN3MMU), cansleep)
#define ALLOC_PTBL_GR(ptr,cansleep)		KMEM_ALLOC(ptr, ELAN3_PTBL_GR *, sizeof (ELAN3_PTBL_GR), cansleep)
#define ALLOC_ELAN3MMU_RGN(ptr,cansleep)	KMEM_ALLOC(ptr, ELAN3MMU_RGN *, sizeof (ELAN3MMU_RGN), cansleep)
#define ALLOC_HMENTS(ptr,cansleep)		KMEM_ALLOC((ptr,ELAN3_HMENT *, sizeof (ELAN3_HMENT), cansleep)

#define FREE_ELAN3MMU(ptr)			KMEM_FREE(ptr,sizeof (ELAN3MMU))
#define FREE_PTBL_GR(ptr)			KMEM_FREE(ptr,sizeof (ELAN3_PTBL_GR))
#define FREE_ELAN3MMU_RGN(ptr)			KMEM_FREE(ptr,sizeof (ELAN3MMU_RGN))
#define FREE_HMENTS(ptr)			KMEM_FREE(ptr,sizeof (ELAN3_HMENT))

extern void	     elan3mmu_init_osdep(void);
extern void	     elan3mmu_fini_osdep(void);

extern void          elan3mmu_pte_range_unload (ELAN3MMU *elan3mmu, struct mm_struct *mm, caddr_t addr, unsigned long len);
extern void          elan3mmu_pte_range_update (ELAN3MMU *elan3mmu, struct mm_struct *mm, caddr_t addr, unsigned long len);
extern void          elan3mmu_pte_ctxt_unload(ELAN3MMU *elan3mmu);

#endif

/*
 * Local variables:
 * c-file-style: "stroustrup"
 * End:
 */
