/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ifndef _ELAN3_ELANDEBUG_H
#define _ELAN3_ELANDEBUG_H

#ident "$Id: elandebug.h,v 1.38 2003/09/24 13:57:24 david Exp $"
/*      $Source: /cvs/master/quadrics/elan3mod/elan3/elan3/elandebug.h,v $ */

#if defined(__KERNEL__)

extern u_int elan3_debug;
extern u_int elan3_debug_console;
extern u_int elan3_debug_buffer;
extern u_int elan3_debug_ignore_dev;
extern u_int elan3_debug_ignore_kcomm;
extern u_int elan3_debug_ignore_ctxt;
extern u_int elan3_debug_display_ctxt;

#define DBG_CONFIG	0x00000001			/* Module configuration */
#define DBG_HAT		0x00000002
#define DBG_FN		0x00000004
#define DBG_SEG		0x00000008
#define DBG_INTR	0x00000010
#define DBG_LWP		0x00000020
#define DBG_FAULT	0x00000040
#define DBG_EVENT	0x00000080
#define DBG_CPROC	0x00000100
#define DBG_TPROC	0x00000200
#define DBG_DPROC	0x00000400
#define DBG_IPROC	0x00000800
#define DBG_SWAP	0x00001000
#define DBG_CMD		0x00002000
#define DBG_VP		0x00004000
#define DBG_SYSCALL	0x00008000
#define DBG_BSCAN	0x00010000
#define DBG_LINKERR	0x00020000
#define DBG_NETERR	0x00040000
#define DBG_NETRPC	0x00080000
#define DBG_EVENTCOOKIE 0x00100000
#define DBG_SDRAM	0x00200000

#define DBG_EP		0x10000000
#define DBG_EPCONSOLE	0x20000000

#define DBG_EIP		0x40000000
#define DBG_EIPFAIL	0x80000000

#define DBG_ALL		0xffffffff

/* values to pass as "ctxt" rather than a "ctxt" pointer */
#define DBG_DEVICE	((void *) 0)
#define DBG_KCOMM	((void *) 1)
#define DBG_ICS		((void *) 2)
#define DBG_USER	((void *) 3)
#define DBG_NTYPES	64

#if defined(DEBUG_PRINTF)
#  define DBG(m,fn)				((elan3_debug&(m)) ? (void)(fn) : (void)0)
#  define PRINTF0(ctxt,m,fmt)	 		((elan3_debug&(m)) ? elan3_debugf(ctxt,m,fmt)             : (void)0)
#  define PRINTF1(ctxt,m,fmt,a)			((elan3_debug&(m)) ? elan3_debugf(ctxt,m,fmt,a)           : (void)0)
#  define PRINTF2(ctxt,m,fmt,a,b)		((elan3_debug&(m)) ? elan3_debugf(ctxt,m,fmt,a,b)         : (void)0)
#  define PRINTF3(ctxt,m,fmt,a,b,c)		((elan3_debug&(m)) ? elan3_debugf(ctxt,m,fmt,a,b,c)       : (void)0)
#  define PRINTF4(ctxt,m,fmt,a,b,c,d)		((elan3_debug&(m)) ? elan3_debugf(ctxt,m,fmt,a,b,c,d)     : (void)0)
#  define PRINTF5(ctxt,m,fmt,a,b,c,d,e)		((elan3_debug&(m)) ? elan3_debugf(ctxt,m,fmt,a,b,c,d,e)   : (void)0)
#  define PRINTF6(ctxt,m,fmt,a,b,c,d,e,f)	((elan3_debug&(m)) ? elan3_debugf(ctxt,m,fmt,a,b,c,d,e,f) : (void)0)
#ifdef __GNUC__
#  define PRINTF(ctxt,m,args...)		((elan3_debug&(m)) ? elan3_debugf(ctxt,m, ##args)         : (void)0)
#endif

#else

#  define DBG(m, fn)				do { ; } while (0)
#  define PRINTF0(ctxt,m,fmt)			do { ; } while (0)
#  define PRINTF1(ctxt,m,fmt,a)			do { ; } while (0)
#  define PRINTF2(ctxt,m,fmt,a,b)		do { ; } while (0)
#  define PRINTF3(ctxt,m,fmt,a,b,c)		do { ; } while (0)
#  define PRINTF4(ctxt,m,fmt,a,b,c,d)		do { ; } while (0)
#  define PRINTF5(ctxt,m,fmt,a,b,c,d,e)		do { ; } while (0)
#  define PRINTF6(ctxt,m,fmt,a,b,c,d,e,f)	do { ; } while (0)
#ifdef __GNUC__
#  define PRINTF(ctxt,m,args...)		do { ; } while (0)
#endif

#endif /* DEBUG_PRINTF */

#ifdef __GNUC__
extern void       elan3_debugf (void *ctxt, unsigned int mode, char *fmt, ...)
    __attribute__ ((format (printf,3,4)));
#else
extern void       elan3_debugf (void *ctxt, unsigned int mode, char *fmt, ...);
#endif


#endif /* __KERNEL__ */
#endif /* _ELAN3_ELANDEBUG_H */

/*
 * Local variables:
 * c-file-style: "stroustrup"
 * End:
 */
