/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ifndef __ELANDEV_LINUX_H
#define __ELANDEV_LINUX_H

#ident "$Id: elandev_linux.h,v 1.14 2005/04/05 15:28:37 robin Exp $"
/*      $Source: /cvs/master/quadrics/elan3mod/elan3/elan3/elandev_linux.h,v $*/

#ifdef __KERNEL__
#include <linux/mm.h>
#include <linux/sched.h>
#include <linux/pci.h>

#include <qsnet/autoconf.h>

#if !defined(NO_COPROC)				/* The older coproc kernel patch is applied */
#include <linux/coproc.h>

#define ioproc_ops		coproc_ops_struct
#define ioproc_register_ops	register_coproc_ops
#define ioproc_unregister_ops	unregister_coproc_ops

#define IOPROC_MM_STRUCT_ARG	1
#define IOPROC_PATCH_APPLIED	1

#elif !defined(NO_IOPROC)			/* The new ioproc kernel patch is applied */
#include <linux/ioproc.h>

#define IOPROC_PATCH_APPLIED	1
#endif
#endif

#define ELAN3_MAJOR              60
#define ELAN3_NAME               "elan3"
#define ELAN3_MAX_CONTROLLER     16                      /* limited to 4 bits */
 
#define ELAN3_MINOR_DEVNUM(m)    ((m) & 0x0f)            /* card number */
#define ELAN3_MINOR_DEVFUN(m)    (((m) >> 4) & 0x0f)     /* function */
#define ELAN3_MINOR_CONTROL      0                       /* function values */
#define ELAN3_MINOR_MEM          1
#define ELAN3_MINOR_USER		2
 
typedef void 			*DeviceMappingHandle;

/* task and ctxt handle types */
typedef struct mm_struct 	*TaskHandle;
typedef int			CtxtHandle;
 
#define ELAN3_MY_TASK_HANDLE()	(current->mm)
#define KERNEL_TASK_HANDLE()	(get_kern_mm())
 
/*
 * OS-dependent component of ELAN3_DEV struct.
 */
typedef struct elan3_dev_osdep
{
	struct pci_dev	*pci;			/* PCI config data */
	int		ControlDeviceOpen;	/* flag to indicate control */
						/*   device open */
       struct proc_dir_entry *procdir;
} ELAN3_DEV_OSDEP;

#endif /* __ELANDEV_LINUX_H */

/*
 * Local variables:
 * c-file-style: "stroustrup"
 * End:
 */
