/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ifndef __ELAN3_ELAN3IO_H
#define __ELAN3_ELAN3IO_H

#ident "$Id: elanio.h,v 1.19 2003/12/08 15:40:26 mike Exp $"
/*      $Source: /cvs/master/quadrics/elan3mod/elan3/elan3/elanio.h,v $*/

#define ELAN3IO_CONTROL_PATHNAME	"/dev/elan3/control%d"
#define ELAN3IO_MEM_PATHNAME	"/dev/elan3/mem%d"
#define ELAN3IO_USER_PATHNAME	"/dev/elan3/user%d"
#define ELAN3IO_SDRAM_PATHNAME   "/dev/elan3/sdram%d"
#define ELAN3IO_MAX_PATHNAMELEN	32

/* ioctls on /dev/elan3/control */
#define ELAN3IO_CONTROL_BASE		0

#define ELAN3IO_SET_BOUNDARY_SCAN	_IO   ('e', ELAN3IO_CONTROL_BASE + 0)
#define ELAN3IO_CLEAR_BOUNDARY_SCAN	_IO   ('e', ELAN3IO_CONTROL_BASE + 1)
#define ELAN3IO_READ_LINKVAL		_IOWR ('e', ELAN3IO_CONTROL_BASE + 2, E3_uint32)
#define ELAN3IO_WRITE_LINKVAL		_IOWR ('e', ELAN3IO_CONTROL_BASE + 3, E3_uint32)

typedef struct elanio_set_debug_struct
{
    char	what[32];
    u_long	value;
} ELAN3IO_SET_DEBUG_STRUCT;
#define ELAN3IO_SET_DEBUG		_IOW  ('e', ELAN3IO_CONTROL_BASE + 4, ELAN3IO_SET_DEBUG_STRUCT)

typedef struct elanio_debug_buffer_struct
{
    caddr_t	addr;
    size_t	len;
} ELAN3IO_DEBUG_BUFFER_STRUCT;
#define ELAN3IO_DEBUG_BUFFER		_IOWR ('e', ELAN3IO_CONTROL_BASE + 5, ELAN3IO_DEBUG_BUFFER_STRUCT)

typedef struct elanio_neterr_server_struct
{
    u_int		elanid;
    void	       *addr;
    char	       *name;
} ELAN3IO_NETERR_SERVER_STRUCT;
#define ELAN3IO_NETERR_SERVER		_IOW  ('e', ELAN3IO_CONTROL_BASE + 6, ELAN3IO_NETERR_SERVER_STRUCT)
#define ELAN3IO_NETERR_FIXUP		_IOWR ('e', ELAN3IO_CONTROL_BASE + 7, NETERR_MSG)

typedef struct elanio_set_position_struct
{
    u_int	        device;
    unsigned short      nodeId;
    unsigned short      numNodes;
} ELAN3IO_SET_POSITION_STRUCT;
#define ELAN3IO_SET_POSITION		_IOW ('e', ELAN3IO_CONTROL_BASE + 8, ELAN3IO_SET_POSITION_STRUCT)

#if defined(LINUX)

/* ioctls on /dev/elan3/sdram */
#define ELAN3IO_SDRAM_BASE		20

/* ioctls on /dev/elan3/user */
#define ELAN3IO_USER_BASE		30

#define ELAN3IO_FREE			_IO  ('e', ELAN3IO_USER_BASE + 0)

#define ELAN3IO_ATTACH			_IOWR('e', ELAN3IO_USER_BASE + 1, ELAN_CAPABILITY)
#define ELAN3IO_DETACH			_IO  ('e', ELAN3IO_USER_BASE + 2)

typedef struct elanio_addvp_struct
{
    u_int		process;
    ELAN_CAPABILITY     capability;
} ELAN3IO_ADDVP_STRUCT;
#define ELAN3IO_ADDVP			_IOWR('e', ELAN3IO_USER_BASE + 3, ELAN3IO_ADDVP_STRUCT)
#define ELAN3IO_REMOVEVP			_IOW ('e', ELAN3IO_USER_BASE + 4, int)

typedef struct elanio_bcastvp_struct
{
    u_int		process;
    u_int		lowvp;
    u_int		highvp;
} ELAN3IO_BCASTVP_STRUCT;
#define ELAN3IO_BCASTVP			_IOW ('e', ELAN3IO_USER_BASE + 5, ELAN3IO_BCASTVP_STRUCT)

typedef struct elanio_loadroute_struct
{
    u_int		process;
    E3_uint16		flits[MAX_FLITS];
} ELAN3IO_LOAD_ROUTE_STRUCT;
#define ELAN3IO_LOAD_ROUTE		_IOW ('e', ELAN3IO_USER_BASE + 6, ELAN3IO_LOAD_ROUTE_STRUCT)

#define ELAN3IO_PROCESS			_IO  ('e', ELAN3IO_USER_BASE + 7)

typedef struct elanio_setperm_struct
{
    caddr_t		maddr;
    E3_Addr		eaddr;
    size_t		len;
    int			perm;
} ELAN3IO_SETPERM_STRUCT;
#define ELAN3IO_SETPERM			_IOW ('e', ELAN3IO_USER_BASE + 8, ELAN3IO_SETPERM_STRUCT)

typedef struct elanio_clearperm_struct
{
    E3_Addr		eaddr;
    size_t		len;
} ELAN3IO_CLEARPERM_STRUCT;
#define ELAN3IO_CLEARPERM		_IOW ('e', ELAN3IO_USER_BASE + 9, ELAN3IO_CLEARPERM_STRUCT)

typedef struct elanio_changeperm_struct
{
    E3_Addr		eaddr;
    size_t		len;
    int			perm;
} ELAN3IO_CHANGEPERM_STRUCT;
#define ELAN3IO_CHANGEPERM		_IOW ('e', ELAN3IO_USER_BASE + 10, ELAN3IO_CHANGEPERM_STRUCT)


#define ELAN3IO_HELPER_THREAD		_IO  ('e', ELAN3IO_USER_BASE + 11)
#define ELAN3IO_WAITCOMMAND		_IO  ('e', ELAN3IO_USER_BASE + 12)
#define ELAN3IO_BLOCK_INPUTTER		_IOW ('e', ELAN3IO_USER_BASE + 13, int)
#define ELAN3IO_SET_FLAGS		_IOW ('e', ELAN3IO_USER_BASE + 14, int)

#define ELAN3IO_WAITEVENT		_IOW ('e', ELAN3IO_USER_BASE + 15, E3_Event)
#define ELAN3IO_ALLOC_EVENTCOOKIE	_IOW ('e', ELAN3IO_USER_BASE + 16, EVENT_COOKIE)
#define ELAN3IO_FREE_EVENTCOOKIE		_IOW ('e', ELAN3IO_USER_BASE + 17, EVENT_COOKIE)
#define ELAN3IO_ARM_EVENTCOOKIE		_IOW ('e', ELAN3IO_USER_BASE + 18, EVENT_COOKIE)
#define ELAN3IO_WAIT_EVENTCOOKIE		_IOW ('e', ELAN3IO_USER_BASE + 19, EVENT_COOKIE)

#define ELAN3IO_SWAPSPACE		_IOW ('e', ELAN3IO_USER_BASE + 20, SYS_SWAP_SPACE)
#define ELAN3IO_EXCEPTION_SPACE		_IOW ('e', ELAN3IO_USER_BASE + 21, SYS_EXCEPTION_SPACE)
#define ELAN3IO_GET_EXCEPTION		_IOR ('e', ELAN3IO_USER_BASE + 22, SYS_EXCEPTION)

typedef struct elanio_unload_struct
{
    void	*addr;
    size_t	 len;
} ELAN3IO_UNLOAD_STRUCT;
#define ELAN3IO_UNLOAD			_IOW ('e', ELAN3IO_USER_BASE + 23, ELAN3IO_UNLOAD_STRUCT)



typedef struct elanio_getroute_struct
{
    u_int		process;
    E3_uint16		flits[MAX_FLITS];
} ELAN3IO_GET_ROUTE_STRUCT;
#define ELAN3IO_GET_ROUTE		_IOW ('e', ELAN3IO_USER_BASE + 24, ELAN3IO_GET_ROUTE_STRUCT)

typedef struct elanio_resetroute_struct
{
    u_int		process;
} ELAN3IO_RESET_ROUTE_STRUCT;
#define ELAN3IO_RESET_ROUTE		_IOW ('e', ELAN3IO_USER_BASE + 25, ELAN3IO_RESET_ROUTE_STRUCT)

typedef struct elanio_checkroute_struct
{
    u_int		process;
    E3_uint32           routeError;
    E3_uint16		flits[MAX_FLITS];
} ELAN3IO_CHECK_ROUTE_STRUCT;
#define ELAN3IO_CHECK_ROUTE		_IOW ('e', ELAN3IO_USER_BASE + 26, ELAN3IO_CHECK_ROUTE_STRUCT)

typedef struct elanio_vp2nodeId_struct
{
    u_int	        process;
    unsigned short      nodeId;
    ELAN_CAPABILITY	cap;
} ELAN3IO_VP2NODEID_STRUCT;
#define ELAN3IO_VP2NODEID	_IOWR('e', ELAN3IO_USER_BASE + 27, ELAN3IO_VP2NODEID_STRUCT)

#define ELAN3IO_SET_SIGNAL	_IOW ('e', ELAN3IO_USER_BASE + 28, int)

typedef struct elanio_process_2_location_struct
{
    u_int		process;
    ELAN_LOCATION       loc;
} ELAN3IO_PROCESS_2_LOCATION_STRUCT;
#define ELAN3IO_PROCESS_2_LOCATION	_IOW ('e', ELAN3IO_USER_BASE + 29, ELAN3IO_PROCESS_2_LOCATION_STRUCT)



/* ioctls on all device */
#define ELAN3IO_GENERIC_BASE		100
typedef struct elanio_get_devinfo_struct
{
    ELAN_DEVINFO *devinfo;
} ELAN3IO_GET_DEVINFO_STRUCT;
#define ELAN3IO_GET_DEVINFO		_IOR ('e', ELAN3IO_GENERIC_BASE + 0, ELAN_DEVINFO)

typedef struct elanio_get_position_struct
{
    ELAN_POSITION *position;
} ELAN3IO_GET_POSITION_STRUCT;
#define ELAN3IO_GET_POSITION             _IOR ('e', ELAN3IO_GENERIC_BASE + 1, ELAN_POSITION)

typedef struct elanio_stats_struct
{
    int		which;
    void       *ptr;
} ELAN3IO_STATS_STRUCT;
#define ELAN3IO_STATS			_IOR ('e', ELAN3IO_GENERIC_BASE + 2, ELAN3IO_STATS_STRUCT)
#  define ELAN3_SYS_STATS_DEVICE	0
#  define ELAN3_SYS_STATS_MMU		1

/* offsets on /dev/elan3/control */

/* offsets on /dev/elan3/mem */

/* page numbers on /dev/elan3/user */
#define ELAN3IO_OFF_COMMAND_PAGE		0
#define ELAN3IO_OFF_FLAG_PAGE		1
#define ELAN3IO_OFF_UREG_PAGE		2

#endif /* LINUX */

#endif /* __ELAN3_ELAN3IO_H */

/*
 * Local variables:
 * c-file-style: "stroustrup"
 * End:
 */
