/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ifndef __ELAN3_NETERR_RPC_H
#define __ELAN3_NETERR_RPC_H

#ident "$Id: neterr_rpc.h,v 1.20 2003/06/26 16:05:22 fabien Exp $"
/*      $Source: /cvs/master/quadrics/elan3mod/elan3/elan3/neterr_rpc.h,v $*/

#define NETERR_SERVICE	"neterr-srv"
#define NETERR_PROGRAM	((u_long) 170002)
#define NETERR_VERSION	((u_long) 1)

#define NETERR_NULL_RPC		0
#define NETERR_FIXUP_RPC	1

/* network error rpc timeout */
#define NETERR_RPC_TIMEOUT	5

/*
 * XDR functions for Tru64 and Linux in userspace. 
 *  NB Linux kernelspace xdr routines are in network_error.
 *     and *must* be kept consistent.
 */
#if defined(DIGITAL_UNIX) || !defined(__KERNEL__)
bool_t
xdr_capability (XDR *xdrs, void *arg)
{
    ELAN_CAPABILITY *cap = (ELAN_CAPABILITY *) arg;

    return (xdr_opaque (xdrs, (caddr_t) &cap->cap_userkey, sizeof (cap->cap_userkey)) &&
	    xdr_int (xdrs, &cap->cap_version) &&
	    xdr_u_short (xdrs, &cap->cap_type) &&
	    xdr_int (xdrs, &cap->cap_lowcontext) &&
	    xdr_int (xdrs, &cap->cap_highcontext) &&
	    xdr_int (xdrs, &cap->cap_mycontext) &&
	    xdr_int (xdrs, &cap->cap_lownode) &&
	    xdr_int (xdrs, &cap->cap_highnode) &&
	    xdr_u_int (xdrs, &cap->cap_railmask) &&
	    xdr_opaque (xdrs, (caddr_t) &cap->cap_bitmap[0], sizeof (cap->cap_bitmap)));
}

bool_t
xdr_neterr_msg (XDR *xdrs, void *req)
{
    NETERR_MSG *msg = (NETERR_MSG *) req;

    return (xdr_u_int (xdrs, &msg->Rail) &&
	    xdr_capability (xdrs, &msg->SrcCapability) &&
	    xdr_capability (xdrs, &msg->DstCapability) &&
	    xdr_u_int (xdrs, &msg->DstProcess) &&
	    xdr_u_int (xdrs, &msg->CookieAddr) &&
	    xdr_u_int (xdrs, &msg->CookieVProc) &&
	    xdr_u_int (xdrs, &msg->NextCookie) &&
	    xdr_u_int (xdrs, &msg->WaitForEop));
}
#endif /* INCLUDE_XDR_INLINE */

/*
 * Local variables:
 * c-file-style: "stroustrup"
 * End:
 */
#endif /* __ELAN3_NETERR_RPC_H */
