/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ifndef __ELAN3_THREADLINKAGE_H
#define	__ELAN3_THREADLINKAGE_H

#ident "$Id: threadlinkage.h,v 1.6 2002/08/09 11:23:34 addy Exp $"
/*      $Source: /cvs/master/quadrics/elan3mod/elan3/elan3/threadlinkage.h,v $*/

#ifdef	__cplusplus
extern "C" {
#endif

#if defined(_ASM) || defined(__LANGUAGE_ASSEMBLY__)

/*
 * Macro to define weak symbol aliases. These are similar to the ANSI-C
 *	#pragma weak name = _name
 * except a compiler can determine type. The assembler must be told. Hence,
 * the second parameter must be the type of the symbol (i.e.: function,...)
 */
#define	ANSI_PRAGMA_WEAK(sym, stype)	\
	.weak	sym; \
	.type sym, #stype; \
/* CSTYLED */ \
sym	= _/**/sym

/*
 * ENTRY provides the standard procedure entry code
 */
#define	ENTRY(x) \
	.section	".text"; \
	.align	4; \
	.global	x; \
x:

/*
 * ENTRY2 is identical to ENTRY but provides two labels for the entry point.
 */
#define	ENTRY2(x, y) \
	.section	".text"; \
	.align	4; \
	.global	x, y; \
/* CSTYLED */ \
x:	; \
y:


/*
 * ALTENTRY provides for additional entry points.
 */
#define	ALTENTRY(x) \
	.global x; \
x:

/*
 * DGDEF and DGDEF2 provide global data declarations.
 *
 * DGDEF provides a word aligned word of storage.
 *
 * DGDEF2 allocates "sz" bytes of storage with **NO** alignment.  This
 * implies this macro is best used for byte arrays.
 *
 * DGDEF3 allocates "sz" bytes of storage with "algn" alignment.
 */
#define	DGDEF2(name, sz) \
	.section	".data"; \
	.global name; \
	.size	name, sz; \
name:

#define	DGDEF3(name, sz, algn) \
	.section	".data"; \
	.align	algn; \
	.global name; \
	.size	name, sz; \
name:

#define	DGDEF(name)	DGDEF3(name, 4, 4)

/*
 * SET_SIZE trails a function and set the size for the ELF symbol table.
 */
#define	SET_SIZE(x) \
	.size	x, (.-x)

#endif /* _ASM || __LANGUAGE_ASSEMBLY__ */

#ifdef	__cplusplus
}
#endif

#endif	/* __ELAN3_THREADLINKAGE_H */

/*
 * Local variables:
 * c-file-style: "stroustrup"
 * End:
 */
