/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ifndef __ELAN3_SYSCALL_H
#define __ELAN3_SYSCALL_H

#ident "$Id: threadsyscall.h,v 1.12 2003/09/24 13:57:24 david Exp $"
/*      $Source: /cvs/master/quadrics/elan3mod/elan3/elan3/threadsyscall.h,v $*/

/* 
 * This file contains the system calls supported from the Elan.
 */
#define ELAN3_DEBUG_TRAPNUM	5	/* thread debugging trap */
#define ELAN3_ABORT_TRAPNUM	6	/* bad abort trap */
#define ELAN3_ELANCALL_TRAPNUM	7	/* elansyscall trap */
#define ELAN3_SYSCALL_TRAPNUM	8	/* new syscall trap */

#define ELAN3_T_SYSCALL_CODE	0	/* offsets in struct elan3_t_syscall */
#define ELAN3_T_SYSCALL_ERRNO	4

#define ELAN3_SYS_open		1
#define ELAN3_SYS_close		2
#define ELAN3_SYS_write		3
#define ELAN3_SYS_read		4
#define ELAN3_SYS_poll		5
#define ELAN3_SYS_ioctl		6
#define ELAN3_SYS_lseek		7
#define ELAN3_SYS_mmap		8
#define ELAN3_SYS_munmap	9
#define ELAN3_SYS_kill		10
#define ELAN3_SYS_getpid	11

#if !defined(SYS_getpid) && defined(__NR_getxpid) 
#define SYS_getpid __NR_getxpid		/* for linux */
#endif

#if !defined(_ASM) && !defined(__LANGUAGE_ASSEMBLY__)

extern int     elan3_t_open (const char *, int, ...);
extern ssize_t elan3_t_write (int, const void *, unsigned);
extern ssize_t elan3_t_read(int, void *, unsigned);
extern int     elan3_t_ioctl(int, int, ...);
extern int     elan3_t_close(int);
extern off_t   elan3_t_lseek(int filedes, off_t offset, int whence);

extern caddr_t elan3_t_mmap(caddr_t, size_t, int, int, int, off_t);
extern int     elan3_t_munmap(caddr_t, size_t);

extern int     elan3_t_getpid(void);
extern void    elan3_t_abort(char *str);

#endif /* !_ASM && ! __LANGUAGE_ASSEMBLY__ */

#endif /* __ELAN3_SYSCALL_H */

/*
 * Local variables:
 * c-file-style: "stroustrup"
 * End:
 */
