/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ifndef _VM_SEG_ELAN3_H
#define _VM_SEG_ELAN3_H

#ident "$Id: vmseg.h,v 1.20 2003/09/24 13:57:24 david Exp $"
/*      $Source: /cvs/master/quadrics/elan3mod/elan3/elan3/vmseg.h,v $*/

#include <elan3/elanuregs.h>

/*
 * This segment maps Elan registers,  it is fixed size and has 8K 
 * pages split up as follows
 *
 *    ----------------------------------------
 *    |    Performance Counters (read-only)  |
 *    ----------------------------------------
 *    |    Flag Page (read-only)	     |
 *    ----------------------------------------
 *    |    Command Port			     |
 *    ----------------------------------------
 */
typedef volatile struct elan3_flagstats 
{
    u_int	CommandFlag;
    u_int	PageFaults;
    u_int	CProcTraps;
    u_int	DProcTraps;
    u_int	TProcTraps;
    u_int	IProcTraps;
    u_int	EopBadAcks;
    u_int	EopResets;
    u_int	DmaNetworkErrors;
    u_int	DmaIdentifyNetworkErrors;
    u_int	ThreadIdentifyNetworkErrors;
    u_int	DmaRetries;
    u_int	ThreadSystemCalls;
    u_int	ThreadElanCalls;
    u_int	LoadVirtualProcess;
} ELAN3_FLAGSTATS;

#ifdef DIGITAL_UNIX
typedef volatile union elan3_flagpage
{
    u_char	   Padding[8192];
    ELAN3_FLAGSTATS Stats;
} ELAN3_FLAGPAGE;

typedef volatile struct elan3_vmseg
{
    E3_CommandPort CommandPort;
    ELAN3_FLAGPAGE  FlagPage;
    E3_User_Regs   UserRegs;
} ELAN3_VMSEG;

#define SEGELAN3_SIZE   (sizeof (ELAN3_VMSEG))

#define SEGELAN3_COMMAND_PORT	0
#define SEGELAN3_FLAG_PAGE	1
#define SEGELAN3_PERF_COUNTERS	2

#endif /* DIGITAL_UNIX */

#endif	/* _VM_SEG_ELAN3_H */

/*
 * Local variables:
 * c-file-style: "stroustrup"
 * End:
 */
