/*
 *    Copyright (c) 2001-2002 by Quadrics Supercomputers World Ltd.
 *    Copyright (c) 2002-2003 by Quadrics Ltd.
 * 
 *    For licensing information please see the supplied COPYING file
 *
 */

#ifndef _ELAN4_DEBUG_H
#define _ELAN4_DEBUG_H

#ident "$Id: debug.h,v 1.21 2005/03/23 11:06:15 david Exp $"
/*      $Source: /cvs/master/quadrics/elan4mod/debug.h,v $ */

/* values for "type" field - note a "ctxt" is permissible */
/* and BUFFER/CONSOLE are for explict calls to elan4_debugf() */
#define DBG_DEVICE	((void *) 0)
#define DBG_USER	((void *) 1)

#define DBG_BUFFER	((void *) 62)
#define DBG_CONSOLE	((void *) 63)
#define DBG_NTYPES	64

/* values for "mode" field */
#define DBG_CONFIG	0x00000001
#define DBG_INTR	0x00000002
#define DBG_MAININT	0x00000004
#define DBG_SDRAM	0x00000008
#define DBG_MMU		0x00000010
#define DBG_REGISTER	0x00000020
#define DBG_CQ		0x00000040
#define DBG_NETWORK_CTX	0x00000080

#define DBG_FLUSH	0x00000100
#define DBG_FILE	0x00000200
#define DBG_CONTROL	0x00000400
#define DBG_MEM		0x00000800

#define DBG_PERM	0x00001000
#define DBG_FAULT	0x00002000
#define DBG_SWAP	0x00004000
#define DBG_TRAP	0x00008000
#define DBG_DDCQ	0x00010000
#define DBG_VP		0x00020000
#define DBG_RESTART	0x00040000
#define DBG_RESUME	0x00080000
#define DBG_CPROC	0x00100000
#define DBG_DPROC	0x00200000
#define DBG_EPROC	0x00400000
#define DBG_IPROC	0x00800000
#define DBG_TPROC	0x01000000
#define DBG_IOPROC	0x02000000
#define DBG_ROUTE	0x04000000
#define DBG_NETERR	0x08000000

#define DBG_ALL		0x7FFFFFFF


#ifdef DEBUG_PRINTF

#  define PRINTF0(type,m,fmt)	 		((elan4_debug&(m) || (type) == DBG_CONSOLE) ? elan4_debugf(type,m,fmt)			: (void)0)
#  define PRINTF1(type,m,fmt,a)			((elan4_debug&(m) || (type) == DBG_CONSOLE) ? elan4_debugf(type,m,fmt,a)		: (void)0)
#  define PRINTF2(type,m,fmt,a,b)		((elan4_debug&(m) || (type) == DBG_CONSOLE) ? elan4_debugf(type,m,fmt,a,b)		: (void)0)
#  define PRINTF3(type,m,fmt,a,b,c)		((elan4_debug&(m) || (type) == DBG_CONSOLE) ? elan4_debugf(type,m,fmt,a,b,c)		: (void)0)
#  define PRINTF4(type,m,fmt,a,b,c,d)		((elan4_debug&(m) || (type) == DBG_CONSOLE) ? elan4_debugf(type,m,fmt,a,b,c,d)		: (void)0)
#  define PRINTF5(type,m,fmt,a,b,c,d,e)		((elan4_debug&(m) || (type) == DBG_CONSOLE) ? elan4_debugf(type,m,fmt,a,b,c,d,e)	: (void)0)
#  define PRINTF6(type,m,fmt,a,b,c,d,e,f)	((elan4_debug&(m) || (type) == DBG_CONSOLE) ? elan4_debugf(type,m,fmt,a,b,c,d,e,f)	: (void)0)
#  define PRINTF7(type,m,fmt,a,b,c,d,e,f,g)	((elan4_debug&(m) || (type) == DBG_CONSOLE) ? elan4_debugf(type,m,fmt,a,b,c,d,e,f,g)	: (void)0)
#  define PRINTF8(type,m,fmt,a,b,c,d,e,f,g,h)	((elan4_debug&(m) || (type) == DBG_CONSOLE) ? elan4_debugf(type,m,fmt,a,b,c,d,e,f,g,h)	: (void)0)
#  define PRINTF9(type,m,fmt,a,b,c,d,e,f,g,h,i)	((elan4_debug&(m) || (type) == DBG_CONSOLE) ? elan4_debugf(type,m,fmt,a,b,c,d,e,f,g,h,i): (void)0)
#ifdef __GNUC__
#  define PRINTF(type,m,args...)		((elan4_debug&(m) || (type) == DBG_CONSOLE) ? elan4_debugf(type,m, ##args)		: (void)0)
#endif
#  define DBGCMD(type,m,cmd)			((elan4_debug&(m) || (type) == DBG_CONSOLE)  ? (void) (cmd) : (void) 0)

#else

#  define PRINTF0(type,m,fmt)			(0)
#  define PRINTF1(type,m,fmt,a)			(0)
#  define PRINTF2(type,m,fmt,a,b)		(0)
#  define PRINTF3(type,m,fmt,a,b,c)		(0)
#  define PRINTF4(type,m,fmt,a,b,c,d)		(0)
#  define PRINTF5(type,m,fmt,a,b,c,d,e)		(0)
#  define PRINTF6(type,m,fmt,a,b,c,d,e,f)	(0)
#  define PRINTF7(type,m,fmt,a,b,c,d,e,f,g)	(0)
#  define PRINTF8(type,m,fmt,a,b,c,d,e,f,g,h)	(0)
#  define PRINTF9(type,m,fmt,a,b,c,d,e,f,g,h,i)	(0)
#ifdef __GNUC__
#  define PRINTF(type,m,args...)
#endif
#  define DBGCMD(type,m,cmd)			((void) 0)

#endif /* DEBUG_PRINTF */

extern unsigned   elan4_debug;
extern unsigned   elan4_debug_toconsole;
extern unsigned   elan4_debug_tobuffer;
extern unsigned   elan4_debug_display_ctxt;
extern unsigned   elan4_debug_ignore_ctxt;
extern unsigned   elan4_debug_ignore_type;

extern void	  elan4_debug_init(void);
extern void	  elan4_debug_fini(void);
extern void       elan4_debugf (void *type, int mode, char *fmt, ...);


/*
 * Local variables:
 * c-file-style: "stroustrup"
 * End:
 */
#endif /* _ELAN4_DEBUG_H */
