/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *    Copyright (c) 2002-2003 by Quadrics Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ifndef _ELAN4_I2C_H
#define _ELAN4_I2C_H

#ident "@(#)$Id: i2c.h,v 1.10 2003/12/02 16:11:22 lee Exp $ $Name: QSNETMODULES-5-11-3_20050907 $"
/*      $Source: /cvs/master/quadrics/elan4hdr/i2c.h,v $*/

/* I2C address space - bits[7:1] */
#define I2C_LED_I2C_ADDR			0x20
#define I2C_TEMP_ADDR				0x48
#define I2C_EEPROM_ADDR				0x50

#define I2C_WRITE_ADDR(addr)			((addr) << 1 | 0)
#define I2C_READ_ADDR(addr)			((addr) << 1 | 1)

/* I2C EEPROM appears as 8 I2C 256 byte devices */
#define I2C_24LC16B_BLOCKSIZE			(256)
#define I2C_24LC16B_BLOCKADDR(addr)		((addr) >> 8)
#define I2C_24LC16B_BLOCKOFFSET(addr)		((addr) & 0xff)

#define I2C_ELAN_EEPROM_PCI_BASEADDR		0	/* PCI config starts at addr 0 in the EEPROM */
#define I2C_ELAN_EEPROM_VPD_BASEADDR		256	/* VPD data start                            */
#define I2C_ELAN_EEPROM_PCI_SIZE		256	/* PCI data max size                         */
#define I2C_ELAN_EEPROM_VPD_SIZE		256	/* VPD data max size                         */

#define I2C_ELAN_EEPROM_SIZE			2048

#define I2C_ELAN_EEPROM_DEVICE_ID		0xA0
#define I2C_ELAN_EEPROM_FAIL_LIMIT              8

#define I2C_ELAN_EEPROM_ADDR_BLOCKSIZE_SHIFT	0x8
#define I2C_ELAN_EEPROM_ADDR_BLOCK_MASK		0x7
#define I2C_ELAN_EEPROM_ADDR_BLOCK_SHIFT	0x1

/*
 * Local variables:
 * c-file-style: "stroustrup"
 * End:
 */
#endif /* _ELAN4_I2C_H */
