/*
 *    Copyright (c) 2001-2002 by Quadrics Supercomputers World Ltd.
 *    Copyright (c) 2002-2003 by Quadrics Ltd.
 * 
 *    For licensing information please see the supplied COPYING file
 *
 */

#ident "@(#)$Id: intcookie.h,v 1.10 2004/08/09 14:02:37 daniel Exp $"
/*      $Source: /cvs/master/quadrics/elan4mod/intcookie.h,v $*/

#ifndef __ELAN4_INTCOOKIE_H
#define __ELAN4_INTCOOKIE_H

typedef E4_uint64 ELAN4_INTCOOKIE;

#ifdef __KERNEL__

typedef struct intcookie_entry
{
    struct intcookie_entry    *ent_next;
    struct intcookie_entry    *ent_prev;

    spinlock_t		       ent_lock;
    unsigned		       ent_ref;

    ELAN4_INTCOOKIE	       ent_cookie;
    ELAN4_INTCOOKIE	       ent_fired;
    kcondvar_t		       ent_wait;
} INTCOOKIE_ENTRY;

typedef struct intcookie_table
{
    struct intcookie_table    *tbl_next;
    struct intcookie_table    *tbl_prev;

    ELAN_CAPABILITY           *tbl_cap;

    spinlock_t	               tbl_lock;
    unsigned	               tbl_ref;
    INTCOOKIE_ENTRY           *tbl_entries;
} INTCOOKIE_TABLE;

extern void                intcookie_init(void);
extern void                intcookie_fini(void);
extern INTCOOKIE_TABLE    *intcookie_alloc_table (ELAN_CAPABILITY *cap);
extern void                intcookie_free_table (INTCOOKIE_TABLE *tbl);
extern int                 intcookie_alloc (INTCOOKIE_TABLE *tbl, ELAN4_INTCOOKIE cookie);
extern int                 intcookie_free (INTCOOKIE_TABLE *tbl, ELAN4_INTCOOKIE cookie);
extern int                 intcookie_fire (INTCOOKIE_TABLE *tbl, ELAN4_INTCOOKIE cookie);
extern int                 intcookie_fire_cap (ELAN_CAPABILITY *cap, ELAN4_INTCOOKIE cookie);
extern int                 intcookie_wait (INTCOOKIE_TABLE *tbl, ELAN4_INTCOOKIE cookie);
extern int                 intcookie_arm (INTCOOKIE_TABLE *tbl, ELAN4_INTCOOKIE cookie);

#endif /* __KERNEL */

/*
 * Local variables:
 * c-file-style: "stroustrup"
 * End:
 */
#endif /* __ELAN4_INTCOOKIE_H */
