/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *    Copyright (c) 2002-2004 by Quadrics Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ifndef __ELAN4_NETERR_H
#define __ELAN4_NETERR_H

#ident "@(#)$Id: neterr.h,v 1.1 2004/01/19 14:38:34 david Exp $ $Name: QSNETMODULES-5-11-3_20050907 $"
/*      $Source: /cvs/master/quadrics/elan4mod/neterr.h,v $*/

typedef struct elan4_neterr_msg
{
    E4_uint8		msg_type;
    E4_uint8		msg_waitforeop;
    E4_uint16		msg_context;				/* network context # message sent to */
    E4_int16		msg_found;				/* # cookie found (response) */

    ELAN_LOCATION	msg_sender;				/* nodeid/context # message sent from */
    E4_uint32		msg_pad;

    E4_uint64		msg_cookies[6];				/* 64 bit cookies from identify packets */
} ELAN4_NETERR_MSG;

#define ELAN4_NETERR_MSG_SIZE		sizeof (ELAN4_NETERR_MSG)
#define ELAN4_NETERR_MSG_REQUEST	1
#define ELAN4_NETERR_MSG_RESPONSE	2

#define ELAN4_NETERR_MAX_COOKIES	(sizeof (((ELAN4_NETERR_MSG *) 0)->msg_cookies) / \
					 sizeof (((ELAN4_NETERR_MSG *) 0)->msg_cookies[0]))

/*
 * Local variables:
 * c-file-style: "stroustrup"
 * End:
 */
#endif /* __ELAN4_NETERR_H */
