/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *    Copyright (c) 2002-2003 by Quadrics Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ifndef __ELAN4_SDRAM_H
#define __ELAN4_SDRAM_H

#ident "$Id: sdram.h,v 1.8 2003/09/24 13:55:55 david Exp $"
/*      $Source: /cvs/master/quadrics/elan4hdr/sdram.h,v $*/

/* Include header file generated by sdram configuration program */
#include <elan4/xsdram.h> 

/* SDRAM bank shift definitions */
#define SDRAM_0_CS_SHIFT	25
#define SDRAM_1_CS_SHIFT	27
#define SDRAM_2_CS_SHIFT	28
#define SDRAM_3_CS_SHIFT	29

#define SDRAM_BANK_SHIFT(cfg) \
	(((cfg >> SDRAM_RamSize_SH) & 3) == 0 ? SDRAM_0_CS_SHIFT : \
	 ((cfg >> SDRAM_RamSize_SH) & 3) == 1 ? SDRAM_1_CS_SHIFT : \
	 ((cfg >> SDRAM_RamSize_SH) & 3) == 2 ? SDRAM_2_CS_SHIFT : SDRAM_3_CS_SHIFT)

#define SDRAM_BANK_SIZE(cfg) 		(1ULL << SDRAM_BANK_SHIFT(cfg))
#define SDRAM_BANK_OFFSET(cfg,bank) 	((unsigned long long)(bank) << SDRAM_BANK_SHIFT(cfg))
#define SDRAM_NUM_BANKS(cfg)		(4)
#define SDRAM_MAX_BANKS			4

/* When the elan access sdram it passes eaddr[12] as sdramaddr[12] when
 * running with a 4k page size, however PCI accesses pass paddr[12], so
 * we must ensure that sdram pages are allocated such that eaddr[12] is the
 * same as paddr[12] - the easiest way is to allocate sdram in 8k chunks and
 * ensure that maddr[12] == eaddr[12] == pgoff[0] */
#define SDRAM_MIN_PAGE_SIZE		(8192)

#endif /* __ELAN4_SDRAM_H */
