/*
 *    Copyright (c) 2001-2002 by Quadrics Supercomputers World Ltd.
 *    Copyright (c) 2002-2003 by Quadrics Ltd.
 * 
 *    For licensing information please see the supplied COPYING file
 *
 */

#ident "@(#)$Id: stats.h,v 1.12 2005/04/19 16:14:52 addy Exp $"
/*      $Source: /cvs/master/quadrics/elan4mod/stats.h,v $*/

#ifndef __ELAN4_STATS_H
#define __ELAN4_STATS_H

#define ELAN4_DEV_STATS_BUCKETS		8


typedef struct elan4_dev_stats
{
    unsigned long	s_interrupts;
    
    unsigned long       s_mainints[ELAN4_DEV_STATS_BUCKETS];
    unsigned long	s_mainint_punts;
    unsigned long	s_mainint_rescheds;

    unsigned long       s_haltints;

    unsigned long	s_cproc_traps;
    unsigned long	s_dproc_traps;
    unsigned long	s_eproc_traps;
    unsigned long	s_iproc_traps;
    unsigned long	s_tproc_traps;

    unsigned long       s_cproc_trap_types[0x10];
    unsigned long       s_dproc_trap_types[7];
    unsigned long       s_eproc_trap_types[4];
    unsigned long       s_iproc_trap_types[0xa];
    unsigned long       s_tproc_trap_types[7];

    unsigned long       s_correctable_errors;
    unsigned long       s_multiple_errors;
    
    unsigned long       s_link_errors;
    unsigned long       s_lock_errors;
    unsigned long       s_deskew_errors;
    unsigned long       s_phase_errors;
    unsigned long	s_data_errors;
    unsigned long	s_fifo_overflow0;
    unsigned long	s_fifo_overflow1;
    unsigned long       s_mod45changed;
    unsigned long       s_pack_not_seen;
    unsigned long       s_linkport_keyfail;

    unsigned long	s_eop_reset;
    unsigned long       s_bad_length;
    unsigned long       s_crc_bad;
    unsigned long       s_crc_error;

    unsigned long	s_cproc_timeout;
    unsigned long	s_dproc_timeout;

    unsigned long	s_sdram_bytes_free;
} ELAN4_DEV_STATS;

#define MainIntBuckets		((int[ELAN4_DEV_STATS_BUCKETS-1]) {1, 2, 3, 4, 8, 16, 32})

#define BumpDevStat(dev,stat)	((dev)->dev_stats.stat++)
#define BucketDevStat(dev,stat,n,bucket)	((n) <= (bucket)[0] ? (dev)->dev_stats.stat[0]++ : \
						 (n) <= (bucket)[1] ? (dev)->dev_stats.stat[1]++ : \
						 (n) <= (bucket)[2] ? (dev)->dev_stats.stat[2]++ : \
						 (n) <= (bucket)[3] ? (dev)->dev_stats.stat[3]++ : \
						 (n) <= (bucket)[4] ? (dev)->dev_stats.stat[4]++ : \
						 (n) <= (bucket)[5] ? (dev)->dev_stats.stat[5]++ : \
						 (n) <= (bucket)[6] ? (dev)->dev_stats.stat[6]++ : \
						                      (dev)->dev_stats.stat[7]++)


/*
 * Local variables:
 * c-file-style: "stroustrup"
 * End:
 */
#endif /*__ELAN4_STATS_H */
