/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *    Copyright (c) 2002-2003 by Quadrics Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ifndef __ELAN4_TYPES_H
#define __ELAN4_TYPES_H

#ident "@(#)$Id: types.h,v 1.9 2003/09/04 12:39:17 david Exp $"
/*      $Source: /cvs/master/quadrics/elan4hdr/types.h,v $*/

#include <qsnet/config.h>
/*
 * "flip" values for correctly indexing into
 * block data which was copied from the Elan
 * using 64 bit accesses.
 */
#if defined(__LITTLE_ENDIAN__)
#  define ByteEndianFlip  0
#  define ShortEndianFlip 0
#  define WordEndianFlip  0
#else
#  define ByteEndianFlip  7
#  define ShortEndianFlip 3
#  define WordEndianFlip  1
#endif


#ifndef _ASM

typedef signed int   	   E4_int;
typedef unsigned int   	   E4_uint;

typedef signed char 	   E4_int8;
typedef unsigned char 	   E4_uint8;

typedef signed short 	   E4_int16;
typedef unsigned short 	   E4_uint16;

typedef signed int   	   E4_int32;
typedef unsigned int   	   E4_uint32;

#ifdef _LP64
typedef signed long        E4_int64;
typedef unsigned long      E4_uint64;
#else
typedef signed long long   E4_int64;
typedef unsigned long long E4_uint64;
#endif

/* 64-bit Elan4 */
typedef E4_uint64	   E4_Addr;
typedef E4_uint32	   E4_LocPhysAddr;	/* Really 31 bits */

#define OneK	(1024)
#define EightK	(8*OneK)

#define E4_DATATYPE_BYTE	0
#define E4_DATATYPE_SHORT	1
#define E4_DATATYPE_WORD	2
#define E4_DATATYPE_DWORD	3

#endif /* _ASM */

#endif /* __ELAN4_TYPES_H */

