/*
 *    Copyright (c) 2001-2002 by Quadrics Supercomputers World Ltd.
 *    Copyright (c) 2002-2003 by Quadrics Ltd.
 * 
 *    For licensing information please see the supplied COPYING file
 *
 */

#ident "@(#)$Id: usertrap.h,v 1.17 2004/05/05 09:08:35 david Exp $"
/*      $Source: /cvs/master/quadrics/elan4mod/usertrap.h,v $*/

#ifndef __ELAN4_USERTRAP_H
#define __ELAN4_USERTRAP_H

#ifndef _ASM
typedef struct elan4_user_page
{
    E4_uint64		upage_ddcq_completed;
} ELAN4_USER_PAGE;

typedef struct elan4_user_trap
{
    int				ut_type;
    unsigned			ut_proc;
    unsigned			ut_args[4];

    union {
	ELAN4_EPROC_TRAP	eproc;
	ELAN4_CPROC_TRAP	cproc;
	ELAN4_DPROC_TRAP	dproc;
	ELAN4_IPROC_TRAP	iproc;
	ELAN4_TPROC_TRAP	tproc;
	ELAN4_NETERR_MSG	msg;
    } 			ut_trap;
} ELAN4_USER_TRAP;

#endif /* _ASM */


/* value for ut_type */
#define UTS_FINISHED		0				/* all pending traps have been handled */
#define UTS_RESCHEDULE		1				/* must return to user mode and re-enter */
#define UTS_UNIMP_INSTR		2				/* unimplemented thread instruction */
#define UTS_EXECUTE_PACKET	3				/* iproc trap needs packet executing */
#define UTS_NETWORK_ERROR_TRAP	4				/* network error on this trap */
#define UTS_NETWORK_ERROR_MSG	5				/* network error message  */
#define UTS_NETWORK_ERROR_TIMER	6				/* network error timer expired */

#define UTS_EFAULT		-1				/* failed to copyout trap */
#define UTS_INVALID_ADDR	-2				/* all -ve codes mean trap could not be resolved. */
#define UTS_INVALID_VPROC	-3
#define UTS_INVALID_COMMAND	-4
#define UTS_BAD_TRAP		-5
#define UTS_ALIGNMENT_ERROR	-6
#define UTS_QUEUE_OVERFLOW	-7
#define UTS_QUEUE_ERROR		-8
#define UTS_INVALID_TRANS	-9
#define UTS_PERMISSION_DENIED	-10
#define UTS_CPROC_ERROR		-11
#define UTS_INVALID_COOKIE	-12
#define UTS_NETERR_ERROR	-13

/* "special" values for registering handlers */
#define UTS_ALL_TRAPS		-9999

/* value for ut_proc */
#define UTS_NOPROC		0
#define UTS_EPROC		1
#define UTS_CPROC		2
#define UTS_DPROC		3
#define UTS_TPROC		4
#define UTS_IPROC		5
#define UTS_NETERR_MSG		6

/* unimplemented trap numbers for thread processor */
#define ELAN4_T_TRAP_INSTR(t)	(0x80202000 | ((t) & 0xFF))

#define ELAN4_T_SYSCALL_TRAP	1
#  define ELAN4_T_OPEN		0
#  define ELAN4_T_WRITE		1
#  define ELAN4_T_READ		2
#  define ELAN4_T_IOCTL		3
#  define ELAN4_T_LSEEK		4
#  define ELAN4_T_POLL		5
#  define ELAN4_T_CLOSE		6
#  define ELAN4_T_KILL		7
#  define ELAN4_T_MMAP		8
#  define ELAN4_T_MUNMAP	9
#  define ELAN4_T_ABORT		100
#  define ELAN4_T_DEBUG		101
#  define ELAN4_T_REGDUMP	102

#define ELAN4_T_REGDUMP_TRAP	2

#define ELAN4_T_LIBELAN_TRAP	3
#  define ELAN4_T_TPORT_NEWBUF	0
#  define ELAN4_T_TPORT_GC	1
#  define ELAN4_T_TPORT_DEBUG	2

#define ELAN4_T_ALLOC_TRAP	4
#  define ELAN4_T_ALLOC_ELAN	0
#  define ELAN4_T_ALLOC_MAIN	1
#  define ELAN4_T_FREE_ELAN	2
#  define ELAN4_T_FREE_MAIN	3

/* reserved main interrupt cookies */
#define ELAN4_INT_COOKIE_DDCQ	0

/*
 * Local variables:
 * c-file-style: "stroustrup"
 * End:
 */
#endif /* __ELAN4_USERTRAP_H */
