/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *    Copyright (c) 2002-2003 by Quadrics Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ifndef __ELAN4_XSDRAM_H
#define __ELAN4_XSDRAM_H

#ident "@(#)$Id: xsdram.h,v 1.13 2004/03/05 12:32:04 jon Exp $ $Name: QSNETMODULES-5-11-3_20050907 $"
/*      $Source: /cvs/master/quadrics/elan4hdr/xsdram.h,v $*/

/* SAMSUNG K4H281638D-TCB3 */

#define SDRAM_tRCF_1_SH         0
#define SDRAM_tRP_1_SH          4
#define SDRAM_tRCD_SH           8
#define SDRAM_tRRD_SH           12
#define SDRAM_tEndWr_SH         16
#define SDRAM_tEndRd_SH         20
#define SDRAM_Burst_SH          24
#define SDRAM_CL_SH             28
#define SDRAM_DsblBypass       (1ULL << 31)
#define SDRAM_RefreshRate_SH    32
#define SDRAM_RamSize_SH        34
#define SDRAM_ReadLtncy_1_SH    36
#define SDRAM_RdOffset_SH       40
#define SDRAM_FlightDelay_SH    42

#define SDRAM_ENABLE_ECC       (1ULL << 44) // Enables error detecting on the ECC.
#define SDRAM_SDRAM_TESTING    (1ULL << 45) // Switches to test mode for checking EEC data bits
#define SDRAM_SETUP            (1ULL << 46) // Writes SDram control reg when set. Also starts

#define SDRAM_CS_MODE0          0ULL         // 64Mbit, 128Mbit, 256Mbit, 512Mbit or 1Gbit (16-bit output)
#define SDRAM_CS_MODE1          1ULL         // 64Mbit, 128Mbit, 256Mbit or 512Mbit (8-bit output)
#define SDRAM_CS_MODE2          2ULL         // 2Gbit (16-bit output) or 1Gbit (8-bit output)
#define SDRAM_CS_MODE3          3ULL         // 4Gbit (16-bit output) or 2Gbit (8-bit output)

#if defined(LINUX) && !defined(CONFIG_MPSAS)
#define SDRAM_STARTUP_VALUE   ((0xbULL << SDRAM_tRCF_1_SH)      | (0x2ULL << SDRAM_tRP_1_SH)       | \
                               (0x3ULL << SDRAM_tRCD_SH)        | (0x2ULL << SDRAM_tRRD_SH)        | \
                               (0xaULL << SDRAM_tEndWr_SH)      | (0x6ULL << SDRAM_tEndRd_SH)      | \
                               (0x8ULL << SDRAM_Burst_SH)       | (0x6ULL << SDRAM_CL_SH)          | \
                               (0x2ULL << SDRAM_RefreshRate_SH) | (0x3ULL << SDRAM_RamSize_SH)     | \
                               (0x1ULL << SDRAM_RdOffset_SH)    | (0x1ULL << SDRAM_FlightDelay_SH) | \
                               (0x4ULL << SDRAM_ReadLtncy_1_SH))
#else
#define SDRAM_STARTUP_VALUE   ((0xbULL << SDRAM_tRCF_1_SH)      | (0x2ULL << SDRAM_tRP_1_SH)       | \
                               (0x3ULL << SDRAM_tRCD_SH)        | (0x2ULL << SDRAM_tRRD_SH)        | \
                               (0xaULL << SDRAM_tEndWr_SH)      | (0x6ULL << SDRAM_tEndRd_SH)      | \
                               (0x8ULL << SDRAM_Burst_SH)       | (0x6ULL << SDRAM_CL_SH)          | \
                               (0x0ULL << SDRAM_RefreshRate_SH) | (0x0ULL << SDRAM_RamSize_SH)     | \
                               (0x1ULL << SDRAM_RdOffset_SH)    | (0x1ULL << SDRAM_FlightDelay_SH) | \
                               (0x4ULL << SDRAM_ReadLtncy_1_SH) | SDRAM_ENABLE_ECC | SDRAM_SETUP)
#endif

#endif /* __ELAN4_XSDRAM_H */
