/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ifndef __QSNET_TYPES_H
#define __QSNET_TYPES_H

#ident "$Id: types.h,v 1.16 2003/08/01 16:21:38 addy Exp $"
/*      $Source: /cvs/master/quadrics/qsnet/types.h,v $*/

/*
 * Include typedefs for ISO/IEC 9899:1990 standard types
 *
 *
 *    The following integer typedefs are used:
 *
 *	int8_t, int16_t, int32_t, int64_t, intptr_t
 *	uint8_t, uint16_t, uint32_t, uint64_t, uintptr_t
 *	uchar_t, ushort_t, uint_t, ulong_t
 *
 *    <sys/types.h> also defines the following:
 *	u_char, u_short, u_int, u_long, caddr_t
 */

#include <qsnet/config.h>

#if defined(SOLARIS) && defined(__KERNEL__)
#  include <sys/inttypes.h>
#endif

#if defined(SOLARIS) && !defined(__KERNEL__)
#  include <inttypes.h>
#  include <sys/types.h>
#endif

#if defined(DIGITAL_UNIX) && defined(__KERNEL__)
#  include <sys/bitypes.h>
#endif

#if defined(DIGITAL_UNIX) && !defined(__KERNEL__)
#  include <inttypes.h>
#  include <sys/types.h>
#endif

#if defined(LINUX) && defined(__KERNEL__)
#  include <linux/types.h>
#endif

#if defined(LINUX) && !defined(__KERNEL__)
#  include <stdint.h>
#  include <inttypes.h>
#  include <sys/types.h>

typedef unsigned char  uchar_t;
typedef unsigned short ushort_t;
typedef unsigned int   uint_t;
typedef unsigned long  ulong_t;
#endif

#if defined(QNX)
#  include <inttypes.h>
#  include <sys/types.h>
#endif

/* Define a type that will represent a Main CPU pointer
 * on both the Main and the Elan
 */
#ifdef __ELAN__

#if defined(_MAIN_LP64)
#define QSNET_MAIN_PTR	uint64_t
#else
#define QSNET_MAIN_PTR	uint32_t
#endif

#else

#ifdef _LP64
#define QSNET_MAIN_PTR	uint64_t
#else
#define QSNET_MAIN_PTR	uint32_t
#endif

#endif


#endif /* __QSNET_TYPES_H */
