/*
 *    Copyright (c) 1996-2002 by Quadrics Supercomputers World Ltd.
 *
 *    For licensing information please see the supplied COPYING file
 *
 */

#ident "@(#)$Id: rmsio.h,v 1.7 2004/08/26 11:49:30 duncan Exp $"
/*      $Source: /cvs/master/quadrics/rmsmod/rmsio.h,v $*/


#ifndef __RMSMOD_RMSIO_H
#define __RMSMOD_RMSIO_H

/* arg is corepath string */
#define RMSIO_SETCOREPATH	_IOW ('r', 1, char)

typedef struct rmsio_getcorepath_struct
{
    pid_t		pid;
    char		*corepath;
    int			maxlen;
} RMSIO_GETCOREPATH_STRUCT;
#define RMSIO_GETCOREPATH	_IOW ('r', 2, RMSIO_GETCOREPATH_STRUCT)

typedef struct rmsio_prgcreate_struct
{
    int			id;
    uid_t		uid;
    int			cpus;
} RMSIO_PRGCREATE_STRUCT;
#define RMSIO_PRGCREATE		_IOW ('r', 3, RMSIO_PRGCREATE_STRUCT)

typedef struct rmsio_prginfo_struct
{
    int			id;
    int			maxpids;
    pid_t		*pids;
    int			*nprocs;
} RMSIO_PRGINFO_STRUCT;
#define RMSIO_PRGINFO		_IOW ('r', 4, RMSIO_PRGINFO_STRUCT)

typedef struct rmsio_prgsignal_struct
{
    int			id;
    int			signo;
} RMSIO_PRGSIGNAL_STRUCT;
#define RMSIO_PRGSIGNAL		_IOW ('r', 5, RMSIO_PRGSIGNAL_STRUCT)

typedef struct rmsio_prgaddcap_struct
{
    int			id;
    int			index;
    ELAN_CAPABILITY	*cap;
} RMSIO_PRGADDCAP_STRUCT;
#define RMSIO_PRGADDCAP		_IOW ('r', 6, RMSIO_PRGADDCAP_STRUCT)
typedef struct rmsio_setcap_struct
{
    int			index;
    int			ctx;
} RMSIO_SETCAP_STRUCT;
#define RMSIO_SETCAP		_IOW ('r', 7, RMSIO_SETCAP_STRUCT)

typedef struct rmsio_getcap_struct
{
    int			index;
    ELAN_CAPABILITY     *cap;
} RMSIO_GETCAP_STRUCT;
#define RMSIO_GETCAP		_IOW ('r', 8, RMSIO_GETCAP_STRUCT)

typedef struct rmsio_getcap_struct32
{
    int			index;
    unsigned int        capptr;
} RMSIO_GETCAP_STRUCT32;
#define RMSIO_GETCAP32		_IOW ('r', 8, RMSIO_GETCAP_STRUCT32)

/* arg is pointer to ncaps */
#define RMSIO_NCAPS		_IOW ('r', 9, int)

typedef struct rmsio_prggetstats_struct
{
    int			id;
    prgstats_old_t	*stats;
} RMSIO_PRGGETSTATS_STRUCT;
#define RMSIO_PRGGETSTATS	_IOW ('r', 10, RMSIO_PRGGETSTATS_STRUCT)

/* arg is program id */
#define RMSIO_PRGSUSPEND	_IOW ('r', 11, int)
#define RMSIO_PRGRESUME		_IOW ('r', 12, int)
#define RMSIO_PRGDESTROY	_IOW ('r', 13, int)

typedef struct rmsio_getprgid_struct
{
    pid_t		pid;
    int		        *id;
} RMSIO_GETPRGID_STRUCT;
#define RMSIO_GETPRGID		_IOW ('r', 14, RMSIO_GETPRGID_STRUCT)

typedef struct rmsio_getprgid_struct32
{
    pid_t		pid;
    unsigned int	idptr;
} RMSIO_GETPRGID_STRUCT32;
#define RMSIO_GETPRGID32	_IOW ('r', 14, RMSIO_GETPRGID_STRUCT32)

/* arg is pointer to index */
#define RMSIO_GETMYCAP		_IOW ('r', 15, int)

typedef struct rmsio_prgids_struct
{
    int			maxids;
    int			*prgids;
    int			*nprgs;
} RMSIO_PRGIDS_STRUCT;
#define RMSIO_PRGIDS		_IOW ('r', 16, RMSIO_PRGIDS_STRUCT)

/* arg is pointer to vp */
#define RMSIO_ELANINITDONE	_IOW ('r', 17, int)

typedef struct rmsio_prgelanpids_struct
{
    int    id;
    int    maxpids;
    int   *vps;
    int   *pids;
    int   *npids;
} RMSIO_PRGELANPIDS_STRUCT;
#define RMSIO_PRGELANPIDS	_IOW ('r', 18, RMSIO_PRGELANPIDS_STRUCT)

typedef struct rmsio_setpset_struct
{
    int    id;
    int    psid;
} RMSIO_SETPSET_STRUCT;
#define RMSIO_SETPSET	        _IOW ('r', 19, RMSIO_SETPSET_STRUCT)

typedef struct rmsio_getpset_struct
{
    int    id;
    int   *psid;
} RMSIO_GETPSET_STRUCT;
#define RMSIO_GETPSET	        _IOW ('r', 20, RMSIO_GETPSET_STRUCT)

/*
 * have to pass a pointer to the stats, the switch
 * statement goes wrong in the module of the size
 * is too large
 */
typedef struct {
    uint64_t ebytes;
    uint64_t exfers;
} elanstats_t;

typedef struct rmsio_setelanstats_struct
{
    int    id;
    elanstats_t *estats;
} RMSIO_SETELANSTATS_STRUCT;
#define RMSIO_SETELANSTATS      _IOW ('r', 21, RMSIO_SETELANSTATS_STRUCT)

typedef struct rmsio_prggetstats2_struct
{
    int			id;
    prgstats_t		*stats;
} RMSIO_PRGGETSTATS2_STRUCT;
#define RMSIO_PRGGETSTATS2	_IOW ('r', 22, RMSIO_PRGGETSTATS2_STRUCT)

typedef struct rmsio_modversion_struct
{
    int *version;
} RMSIO_MODVERSION_STRUCT;
#define RMSIO_MODVERSION	_IOW ('r', 23, RMSIO_MODVERSION_STRUCT)

typedef struct rmsio_proc_struct
{
    int    id;
    pid_t  pid;
} RMSIO_PROC_STRUCT;
#define RMSIO_ADDPROC           _IOW ('r', 24, RMSIO_PROC_STRUCT)
#define RMSIO_REMOVEPROC        _IOW ('r', 25, RMSIO_PROC_STRUCT)



#endif /* __RMSMOD_RMSIO_H */









