/* -*- linux-c -*-
 *
 *    Copyright (C) 2002-2004 Quadrics Ltd.
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 */

/*
 * Registration for IO processor page table updates.
 */

#include <linux/kernel.h>
#include <linux/module.h>

#include <linux/mm.h>
#include <linux/ioproc.h>

int
ioproc_register_ops(struct mm_struct *mm, struct ioproc_ops *ip)
{
	ip->next = mm->ioproc_ops;
	mm->ioproc_ops = ip;

	return 0;
}

EXPORT_SYMBOL_GPL(ioproc_register_ops);

int
ioproc_unregister_ops(struct mm_struct *mm, struct ioproc_ops *ip)
{
	struct ioproc_ops **tmp;

	for (tmp = &mm->ioproc_ops; *tmp && *tmp != ip; tmp= &(*tmp)->next)
		;
	if (*tmp) {
		*tmp = ip->next;
		return 0;
	}

	return -EINVAL;
}

EXPORT_SYMBOL_GPL(ioproc_unregister_ops);
